var {
  ProgressCircle
} = require("@ladifire-ui-react/progress");

var _ladifireCssSassComponentsScrollbarScss = $parcel$interopDefault(require("@ladifire-css/sass/components/scrollbar.scss"));

var _classnames = $parcel$interopDefault(require("classnames"));

var _ladifireCssSassIndexScss = $parcel$interopDefault(require("@ladifire-css/sass/index.scss"));

var {
  forEach,
  isEqual,
  noop,
  isFunction,
  flatMap
} = require("lodash");

var {
  classNames,
  KeyCommands: _KeyCommands
} = require("@ladifire-ui-react/utils");

var _reactDom = $parcel$exportWildcard({}, require("react-dom"));

var _react3 = require("react");

var _react = $parcel$exportWildcard({}, _react3);

var _react2 = $parcel$interopDefault(_react3);

var _babelRuntimeHelpersExtends = $parcel$interopDefault(require("@babel/runtime/helpers/extends"));

function $parcel$interopDefault(a) {
  return a && a.__esModule ? a.default : a;
}

function $parcel$exportWildcard(dest, source) {
  Object.keys(source).forEach(function (key) {
    if (key === 'default' || key === '__esModule') {
      return;
    }

    Object.defineProperty(dest, key, {
      enumerable: true,
      get: function get() {
        return source[key];
      }
    });
  });
  return dest;
}

var $parcel$global = typeof globalThis !== 'undefined' ? globalThis : typeof self !== 'undefined' ? self : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : {};
// import type WindowScroller from '../WindowScroller.js';
let $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances = [];
let $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$originalBodyPointerEvents = null;
let $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$disablePointerEventsTimeoutId = null;

function $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$enablePointerEventsIfDisabled() {
  if ($b5e81bb20ab209b9608ee3cd1eaf9cc2$var$disablePointerEventsTimeoutId) {
    $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$disablePointerEventsTimeoutId = null;

    if (document.body && $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$originalBodyPointerEvents != null) {
      document.body.style.pointerEvents = $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$originalBodyPointerEvents;
    }

    $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$originalBodyPointerEvents = null;
  }
}

function $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$enablePointerEventsAfterDelayCallback() {
  $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$enablePointerEventsIfDisabled();
  $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances.forEach(instance => instance.__resetIsScrolling());
}

function $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$enablePointerEventsAfterDelay() {
  if ($b5e81bb20ab209b9608ee3cd1eaf9cc2$var$disablePointerEventsTimeoutId) {
    $d9cac488fcbfeca204fd79530e253cdc$export$cancelAnimationTimeout($b5e81bb20ab209b9608ee3cd1eaf9cc2$var$disablePointerEventsTimeoutId);
  }

  var maximumTimeout = 0;
  $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances.forEach(instance => {
    maximumTimeout = Math.max(maximumTimeout, instance.props.scrollingResetTimeInterval);
  });
  $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$disablePointerEventsTimeoutId = $d9cac488fcbfeca204fd79530e253cdc$export$requestAnimationTimeout($b5e81bb20ab209b9608ee3cd1eaf9cc2$var$enablePointerEventsAfterDelayCallback, maximumTimeout);
}

function $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$onScrollWindow(event) {
  if (event.currentTarget === window && $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$originalBodyPointerEvents == null && document.body) {
    $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$originalBodyPointerEvents = document.body.style.pointerEvents;
    document.body.style.pointerEvents = 'none';
  }

  $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$enablePointerEventsAfterDelay();
  $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances.forEach(instance => {
    if (instance.props.scrollElement === event.currentTarget) {
      instance.__handleWindowScrollEvent();
    }
  });
}

function $b5e81bb20ab209b9608ee3cd1eaf9cc2$export$registerScrollListener(component, //WindowScroller,
element) {
  if (!$b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances.some(instance => instance.props.scrollElement === element)) {
    element.addEventListener('scroll', $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$onScrollWindow);
  }

  $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances.push(component);
}

function $b5e81bb20ab209b9608ee3cd1eaf9cc2$export$unregisterScrollListener(component, //WindowScroller,
element) {
  $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances = $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances.filter(instance => instance !== component);

  if (!$b5e81bb20ab209b9608ee3cd1eaf9cc2$var$mountedInstances.length) {
    element.removeEventListener('scroll', $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$onScrollWindow);

    if ($b5e81bb20ab209b9608ee3cd1eaf9cc2$var$disablePointerEventsTimeoutId) {
      $d9cac488fcbfeca204fd79530e253cdc$export$cancelAnimationTimeout($b5e81bb20ab209b9608ee3cd1eaf9cc2$var$disablePointerEventsTimeoutId);
      $b5e81bb20ab209b9608ee3cd1eaf9cc2$var$enablePointerEventsIfDisabled();
    }
  }
}

// TODO Move this into WindowScroller and import from there
const $a81cbc308d9bc6cba10f5b16eba8f67e$var$isWindow = element => element === window;

const $a81cbc308d9bc6cba10f5b16eba8f67e$var$getBoundingBox = element => element.getBoundingClientRect();

function $a81cbc308d9bc6cba10f5b16eba8f67e$export$getDimensions(scrollElement, props) {
  if (!scrollElement) {
    return {
      height: props.serverHeight,
      width: props.serverWidth
    };
  } else if ($a81cbc308d9bc6cba10f5b16eba8f67e$var$isWindow(scrollElement)) {
    const {
      innerHeight,
      innerWidth
    } = window;
    return {
      height: typeof innerHeight === 'number' ? innerHeight : 0,
      width: typeof innerWidth === 'number' ? innerWidth : 0
    };
  } else {
    return $a81cbc308d9bc6cba10f5b16eba8f67e$var$getBoundingBox(scrollElement);
  }
}
/**
 * Gets the vertical and horizontal position of an element within its scroll container.
 * Elements that have been “scrolled past” return negative values.
 * Handles edge-case where a user is navigating back (history) from an already-scrolled page.
 * In this case the body’s top or left position will be a negative number and this element’s top or left will be increased (by that amount).
 */


function $a81cbc308d9bc6cba10f5b16eba8f67e$export$getPositionOffset(element, container) {
  if ($a81cbc308d9bc6cba10f5b16eba8f67e$var$isWindow(container) && document.documentElement) {
    const containerElement = document.documentElement;
    const elementRect = $a81cbc308d9bc6cba10f5b16eba8f67e$var$getBoundingBox(element);
    const containerRect = $a81cbc308d9bc6cba10f5b16eba8f67e$var$getBoundingBox(containerElement);
    return {
      top: elementRect.top - containerRect.top,
      left: elementRect.left - containerRect.left
    };
  } else {
    const scrollOffset = $a81cbc308d9bc6cba10f5b16eba8f67e$export$getScrollOffset(container);
    const elementRect = $a81cbc308d9bc6cba10f5b16eba8f67e$var$getBoundingBox(element);
    const containerRect = $a81cbc308d9bc6cba10f5b16eba8f67e$var$getBoundingBox(container);
    return {
      top: elementRect.top + scrollOffset.top - containerRect.top,
      left: elementRect.left + scrollOffset.left - containerRect.left
    };
  }
}
/**
 * Gets the vertical and horizontal scroll amount of the element, accounting for IE compatibility
 * and API differences between `window` and other DOM elements.
 */


function $a81cbc308d9bc6cba10f5b16eba8f67e$export$getScrollOffset(element) {
  if ($a81cbc308d9bc6cba10f5b16eba8f67e$var$isWindow(element) && document.documentElement) {
    return {
      top: 'scrollY' in window ? window.scrollY : document.documentElement.scrollTop,
      left: 'scrollX' in window ? window.scrollX : document.documentElement.scrollLeft
    };
  } else {
    return {
      top: element.scrollTop,
      left: element.scrollLeft
    };
  }
}

/**
 * Specifies the number of miliseconds during which to disable pointer events while a scroll is in progress.
 * This improves performance and makes scrolling smoother.
 */
const $da443373e4b605c5fa02d1f9f831$export$IS_SCROLLING_TIMEOUT = 150;

const $da443373e4b605c5fa02d1f9f831$var$getWindow = () => typeof window !== 'undefined' ? window : undefined;

class WindowScroller extends _react.PureComponent {
  constructor() {
    super(...arguments);
    this._window = $da443373e4b605c5fa02d1f9f831$var$getWindow();
    this._isMounted = false;
    this._positionFromTop = 0;
    this._positionFromLeft = 0;
    this._detectElementResize = void 0;
    this._child = void 0;
    this.state = _babelRuntimeHelpersExtends({}, $a81cbc308d9bc6cba10f5b16eba8f67e$export$getDimensions(this.props.scrollElement, this.props), {
      isScrolling: false,
      scrollLeft: 0,
      scrollTop: 0
    });

    this._registerChild = element => {
      if (element && !(element instanceof Element)) {
        console.warn('WindowScroller registerChild expects to be passed Element or null');
      }

      this._child = element;
      this.updatePosition();
    };

    this._onChildScroll = (_ref) => {
      let {
        scrollTop
      } = _ref;

      if (this.state.scrollTop === scrollTop) {
        return;
      }

      const scrollElement = this.props.scrollElement;

      if (scrollElement) {
        if (typeof scrollElement.scrollTo === 'function') {
          scrollElement.scrollTo(0, scrollTop + this._positionFromTop);
        } else {
          scrollElement.scrollTop = scrollTop + this._positionFromTop;
        }
      }
    };

    this._registerResizeListener = element => {
      if (element === window) {
        window.addEventListener('resize', this._onResize, false);
      } else {
        this._detectElementResize.addResizeListener(element, this._onResize);
      }
    };

    this._unregisterResizeListener = element => {
      if (element === window) {
        window.removeEventListener('resize', this._onResize, false);
      } else if (element) {
        this._detectElementResize.removeResizeListener(element, this._onResize);
      }
    };

    this._onResize = () => {
      this.updatePosition();
    };

    this.__handleWindowScrollEvent = () => {
      if (!this._isMounted) {
        return;
      }

      const {
        onScroll
      } = this.props;
      const scrollElement = this.props.scrollElement;

      if (scrollElement) {
        const scrollOffset = $a81cbc308d9bc6cba10f5b16eba8f67e$export$getScrollOffset(scrollElement);
        const scrollLeft = Math.max(0, scrollOffset.left - this._positionFromLeft);
        const scrollTop = Math.max(0, scrollOffset.top - this._positionFromTop);
        this.setState({
          isScrolling: true,
          scrollLeft,
          scrollTop
        });
        onScroll({
          scrollLeft,
          scrollTop
        });
      }
    };

    this.__resetIsScrolling = () => {
      this.setState({
        isScrolling: false
      });
    };
  }

  updatePosition(scrollElement) {
    if (scrollElement === void 0) {
      scrollElement = this.props.scrollElement;
    }

    const {
      onResize
    } = this.props;
    const {
      height,
      width
    } = this.state;

    const thisNode = this._child || _reactDom.findDOMNode(this);

    if (thisNode instanceof Element && scrollElement) {
      const offset = $a81cbc308d9bc6cba10f5b16eba8f67e$export$getPositionOffset(thisNode, scrollElement);
      this._positionFromTop = offset.top;
      this._positionFromLeft = offset.left;
    }

    const dimensions = $a81cbc308d9bc6cba10f5b16eba8f67e$export$getDimensions(scrollElement, this.props);

    if (height !== dimensions.height || width !== dimensions.width) {
      this.setState({
        height: dimensions.height,
        width: dimensions.width
      });
      onResize({
        height: dimensions.height,
        width: dimensions.width
      });
    }
  }

  componentDidMount() {
    const scrollElement = this.props.scrollElement;
    this._detectElementResize = $ca6b875d36bb40f35f34ccb5eee9ec5d$export$default();
    this.updatePosition(scrollElement);

    if (scrollElement) {
      $b5e81bb20ab209b9608ee3cd1eaf9cc2$export$registerScrollListener(this, scrollElement);

      this._registerResizeListener(scrollElement);
    }

    this._isMounted = true;
  }

  componentDidUpdate(prevProps, prevState) {
    const {
      scrollElement
    } = this.props;
    const {
      scrollElement: prevScrollElement
    } = prevProps;

    if (prevScrollElement !== scrollElement && prevScrollElement != null && scrollElement != null) {
      this.updatePosition(scrollElement);
      $b5e81bb20ab209b9608ee3cd1eaf9cc2$export$unregisterScrollListener(this, prevScrollElement);
      $b5e81bb20ab209b9608ee3cd1eaf9cc2$export$registerScrollListener(this, scrollElement);

      this._unregisterResizeListener(prevScrollElement);

      this._registerResizeListener(scrollElement);
    }
  }

  componentWillUnmount() {
    const scrollElement = this.props.scrollElement;

    if (scrollElement) {
      $b5e81bb20ab209b9608ee3cd1eaf9cc2$export$unregisterScrollListener(this, scrollElement);

      this._unregisterResizeListener(scrollElement);
    }

    this._isMounted = false;
  }

  render() {
    const {
      children
    } = this.props;
    const {
      isScrolling,
      scrollTop,
      scrollLeft,
      height,
      width
    } = this.state;
    return children({
      onChildScroll: this._onChildScroll,
      registerChild: this._registerChild,
      height,
      isScrolling,
      scrollLeft,
      scrollTop,
      width
    });
  }

}

exports.WindowScroller = WindowScroller;
WindowScroller.defaultProps = {
  onResize: () => {},
  onScroll: () => {},
  scrollingResetTimeInterval: $da443373e4b605c5fa02d1f9f831$export$IS_SCROLLING_TIMEOUT,
  scrollElement: $da443373e4b605c5fa02d1f9f831$var$getWindow(),
  serverHeight: 0,
  serverWidth: 0
};

function useHorizontalLayout(props) {
  // const [sizes, setSizes] = React.useState<Record<string, [number, number]>>({});
  const handleSelectedChange = () => {};

  const [sizes, setSizes] = _react.useState({}); // const handleSetSize = (key: string, size: [number, number]) => {
  //   setSizes({
  //     ...sizes,
  //     [key]: size,
  //   })
  // };


  const handleSetSize = _react.useCallback((key, size) => {
    console.log('calllllllxxxx', key, size);

    if (key in sizes && sizes[key] === size) {
      return;
    }

    setSizes(_babelRuntimeHelpersExtends({}, sizes, {
      [key]: size
    }));
  }, [sizes]);

  console.log('sizessizessizes: ', sizes);

  const getSize = key => {
    if (key in sizes) {
      return sizes[key];
    }

    return [50, 50];
  };

  return {
    sizes,
    setSize: handleSetSize,
    getSize
  };
}

exports.useHorizontalLayout = useHorizontalLayout;

class $b798aa41f8c6378444ca6c3aae67af0b$var$BaseWidthCache {
  constructor() {
    const r = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {},
          t = r.DEFAULT_WIDTH,
          n = void 0 === t ? 50 : t;
    this.widths = {};
    this.DEFAULT_WIDTH = n;
  }

  get(r) {
    if (r in this.widths) return this.widths[r];
    return this.DEFAULT_WIDTH;
  }

  set(r, t) {
    this.widths[r] = t;
  }

  getValidity(r) {
    return r in this.widths;
  }

}

class $b798aa41f8c6378444ca6c3aae67af0b$export$default extends $b798aa41f8c6378444ca6c3aae67af0b$var$BaseWidthCache {
  constructor() {
    const t = super();
    t.validity = {};
    return t;
  }

  getValidity(r) {
    return !!this.validity[r];
  }

  set(t, n) {
    super.set(t, n);
    this.validity[t] = true;
  }

  invalidate(r) {
    if (!r) {
      this.validity = {};
      return;
    }

    delete this.validity[r];
  }

}

class $e6405ab9e26a78a6ceffaeaa9605a91$var$LayoutBase {
  constructor(props) {
    this.widthCache = void 0;
    this.totalWidth = 0;
    this.containerWidth = 0;
    this.keys = void 0;
    this.lefts = {};
    const r = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {},
          a = r.keys,
          n = void 0 === a ? [] : a,
          s = r.widthCache,
          l = void 0 === s ? new $b798aa41f8c6378444ca6c3aae67af0b$export$default() : s;
    this.keys = n;
    this.widthCache = l;
    this.layout();
  }

  invalidate() {
    this.widthCache.invalidate();
  }

  layout() {
    const r = this;
    const a = this.keys;
    const n = {};
    let t = 0;
    forEach(a, function (e) {
      n[e] = t;
      t += r.getWidth(e);
    });
    this.lefts = n;
    this.totalWidth = t;
  }

  getWidth(r) {
    return this.widthCache.get(r);
  }

  getTotalWidthToItemIndex(index) {
    let res = 0;

    for (let i = 0; i < index; i++) {
      const key = this.keys[index];
      res += this.getWidth(key);
    }

    return res;
  }

  getWidthValidity(r) {
    return this.widthCache.getValidity(r);
  }

  getLeft(r) {
    return this.lefts[r];
  }

  getRight(r) {
    return this.lefts[r] + this.getWidth(r);
  }

  getLefts() {
    return this.lefts;
  }

  getTotalWidth() {
    return this.totalWidth;
  }

  getOffsetForKey(r) {
    if (!r) return this.totalWidth;
    return this.getLeft(r);
  }

  getBounds(r, a) {
    const n = this.keys;
    let t = 0;

    while (t + 1 < n.length) {
      const s = n[t + 1];
      const l = this.getLeft(s);
      if (l > r) break;
      t += 1;
    }

    let o = t;

    while (o < n.length) {
      const i = n[o];
      const u = this.getLeft(i);
      if (u > a) break;
      o += 1;
    }

    return {
      start: t,
      end: o
    };
  }

  setWidth(r, a) {
    this.widthCache.set(r, a);
    this.layout();
  }

  setKeys(r) {
    this.keys = r;
    this.layout();
  }

}

class $e6405ab9e26a78a6ceffaeaa9605a91$export$default extends $e6405ab9e26a78a6ceffaeaa9605a91$var$LayoutBase {
  constructor() {
    var _temp;

    const e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {},
          a = e.keys,
          r = e.widthCache,
          i = e.containerWidth,
          s = void 0 === i ? 0 : i,
          o = e.stickToRight,
          c = void 0 !== o && o,
          u = e.rightMargin,
          d = void 0 === u ? 0 : u,
          p = e.ANCHOR_OFFSET,
          m = void 0 === p ? 0 : p,
          h = e.STICKY_EPSILON,
          f = void 0 === h ? 2 : h,
          v = e.STICKY_EPSILON_SETWIDTH,
          b = void 0 === v ? 2 : v;
    const g = (_temp = super({
      keys: a,
      widthCache: r
    }), this.containerWidth = void 0, _temp);
    g.containerWidth = s;
    g.stickToRight = c;
    g.rightMargin = d;
    g.STICKY_EPSILON = f;
    g.STICKY_EPSILON_SETWIDTH = b;
    g.ANCHOR_OFFSET = m;
    g.anchorOffset = m;
    g.anchor = false;
    return g;
  }

  getOffsetForKey(t) {
    if (!t) return this.totalWidth;
    const a = this.getLeft(t);
    if (void 0 === a) return 0;
    return a - this.anchorOffset;
  }

  setWidth(a, r, n) {
    if (false !== this.anchor) {
      super.setWidth(a, r);
      return this.bracketScrollLeft(this.getOffsetForKey(this.anchor));
    }

    if (this.shouldStickToRight(n, this.STICKY_EPSILON_SETWIDTH)) {
      super.setWidth(a, r);
      return this.bracketScrollLeft(Infinity);
    }

    let i = n;
    const s = this.getRight(a);

    if (s <= n + this.anchorOffset) {
      const o = r - this.getWidth(a);
      i += o;
    }

    super.setWidth(a, r);
    return this.bracketScrollLeft(i);
  }

  setKeys(a, r) {
    if (false !== this.anchor) {
      super.setKeys(a);
      return this.bracketScrollLeft(this.getOffsetForKey(this.anchor));
    }

    if (this.shouldStickToRight(r)) {
      super.setKeys(a);
      return this.bracketScrollLeft(Infinity);
    }

    const n = r + this.anchorOffset;
    const i = this.findAnchor(this.keys, a, n);

    if (!i) {
      super.setKeys(a);
      return this.bracketScrollLeft(r);
    }

    const s = this.getLeft(i) - n;
    super.setKeys(a);
    const o = this.getLeft(i) - n;
    const l = s - o;
    return this.bracketScrollLeft(r - l);
  }

  setContainerWidth(t, a) {
    if (false !== this.anchor) {
      this.containerWidth = t;
      this.layout();
      return this.bracketScrollLeft(this.getOffsetForKey(this.anchor));
    }

    if (this.shouldStickToRight(a)) {
      this.containerWidth = t;
      this.layout();
      return this.bracketScrollLeft(Infinity);
    }

    this.containerWidth = t;
    this.layout();
    return a;
  }

  setrightMargin(t) {
    this.rightMargin = t;
  }

  setstickToRight(t) {
    this.stickToRight = t;
  }

  setAnchor(t, a) {
    this.anchor = t;
    this.anchorOffset = 'number' !== typeof a ? this.ANCHOR_OFFSET : a;
  }

  findAnchor(t, a, r) {
    for (let n = 0; n < t.length; n++) {
      const i = t[n];
      if (this.getRight(i) > r) for (let s = 0; s < a.length; s++) if (a[s] === i) return i;
    }

    return null;
  }

  bracketScrollLeft(t) {
    return Math.max(0, Math.min(this.totalWidth - this.containerWidth + this.rightMargin, t));
  }

  shouldStickToRight(t) {
    const a = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : this.STICKY_EPSILON;
    if (!this.stickToRight) return false;
    return t >= this.totalWidth - this.containerWidth - a + this.rightMargin;
  }

  ajustItemWidth(keys, addWidth) {// console.log("need ajust key: ", addWidth);
    // // const newWidthsCache = {};
    // const willAdd = addWidth / keys.length;
    // mapValues( this.widthCache.widths, ( value, oldItemKey ) => {
    // 	// newWidthsCache[ oldItemKey ] = value + willAdd;
    // 	// console.log( 'oldItemKey', oldItemKey );
    // 	// console.log( 'value', value );
    // 	// console.log( 'addWidth', addWidth );
    // 	includes( keys, oldItemKey ) && super.setWidth( oldItemKey, value + willAdd );
    // } );
    // this.widthCache = newWidthsCache;
    // this.layout();
  }

}

class $b3fd0a34233f948fbd21a003f4c$export$default extends _react2.Component {
  constructor(props) {
    super(props);
    this.mutationObserver = void 0;

    this.setRef = r => {
      this.node = r;
    };

    this.setRef = this.setRef.bind(this);
    this.updateSize = this.updateSize.bind(this);
    this.mutationObserver = new MutationObserver(this.updateSize);
    this.node = null;
  }

  componentDidMount() {
    if (this.node) {
      this.mutationObserver.observe(this.node, {
        childList: true,
        subtree: true,
        attributes: true,
        characterData: true
      });
      this.node.addEventListener('load', this.updateSize, true);
    }

    this.updateSize();
  }

  componentDidUpdate() {
    this.updateSize();
  }

  componentWillUnmount() {
    if (this.mutationObserver) {
      this.mutationObserver.disconnect();
      this.mutationObserver = null;
    }
  }

  shouldComponentUpdate(nextProps) {
    if (!isEqual(nextProps.style, this.props.style)) return true;
    if (this.props.children && nextProps.children && !isEqual(nextProps.children.props, this.props.children.props)) return true;
    if (this.props.children && nextProps.children && nextProps.children.key !== this.props.children.key) return true;
    if (nextProps.width !== this.props.width) return true;
    if (!nextProps.validity) return true;
    if (nextProps.hasFocus !== this.props.hasFocus) return true;
    if (nextProps.isMouseDownOnItem !== this.props.isMouseDownOnItem) return true;
    if (nextProps.hasFocusWithin !== this.props.hasFocusWithin) return true;
    return false;
  }

  updateSize() {
    if (!this.node) return;
    const r = this.node.getBoundingClientRect(),
          a = r.width,
          b = r.height; // console.log("called update width");

    (Math.abs(a - this.props.size[0]) > 0.5 || Math.abs(a - this.props.size[1]) > 0.5 || !this.props.validity) && this.props.onSizeChange(this.props.id, [a, b]);
  }

  render() {
    if (!this.props.children) return null;
    return /*#__PURE__*/_react2.createElement("div", {
      key: this.props.id,
      ref: this.setRef,
      style: Object.assign(this.props.style, {
        position: 'absolute'
      })
    }, this.props.children);
  }

}

$b3fd0a34233f948fbd21a003f4c$export$default.defaultProps = {
  onWidthChange: noop,
  style: {},
  validity: false
};

const HorizontalList = props => {
  const {
    keys,
    itemRenderer,
    onWidthChange,
    containerWidth,
    width
  } = props;
  console.log('containerWidth: ', containerWidth);

  const _layout = new $e6405ab9e26a78a6ceffaeaa9605a91$export$default();

  _react.useEffect(() => {
    // _layout.invalidate();
    console.log('_layout: ', _layout);
  }, [containerWidth]);

  _react.useEffect(() => {
    _layout.setKeys(keys);
  }, [keys]);

  const getLeft = key => {
    return _layout.getLeft(key);
  };

  const getTotalWidth = () => {
    return _layout.getTotalWidth();
  };

  const getValidity = key => {
    return _layout.getWidthValidity(key);
  };

  const setWidth = (key, size) => {
    console.log('called set width for: ', key, size);

    _layout.setWidth(key, size);

    setTimeout(() => {
      onWidthChange(_layout.getTotalWidth());
    }, 0);
  };

  const renderItem = key => {
    const _left = getLeft(key);

    const _width = _layout.getWidth(key);

    const _validity = getValidity(key);

    console.log('_left:::+++', _left);
    console.log('_validity:::+++', _validity);
    return /*#__PURE__*/_react.createElement($b3fd0a34233f948fbd21a003f4c$export$default, {
      id: key,
      key: key,
      width: _width,
      validity: _validity,
      style: {
        left: _left
      },
      onWidthChange: setWidth
    }, itemRenderer(key));
  };

  console.log('width: ', getTotalWidth());
  return /*#__PURE__*/_react.createElement("div", {
    className: classNames(_ladifireCssSassIndexScss, _ladifireCssSassIndexScss.position__relative, _ladifireCssSassIndexScss.overflow_y__hidden, _ladifireCssSassIndexScss.overflow_x__hidden),
    style: {
      width,
      height: 200,
      position: 'relative'
    }
  }, keys && keys.length && keys.map(renderItem)); // return (
  //   <div>
  //     {keys && keys.length && keys.map(renderItem)}
  //   </div>
  // );
};

exports.HorizontalList = HorizontalList;
// Properly handle server-side rendering.
let $fd039c0bada58f051dc06594af6ba$var$win;

if (typeof window !== 'undefined') {
  $fd039c0bada58f051dc06594af6ba$var$win = window;
} else if (typeof self !== 'undefined') {
  $fd039c0bada58f051dc06594af6ba$var$win = self;
} else {
  $fd039c0bada58f051dc06594af6ba$var$win = {};
} // requestAnimationFrame() shim by Paul Irish
// http://paulirish.com/2011/requestanimationframe-for-smart-animating/


const $fd039c0bada58f051dc06594af6ba$var$request = $fd039c0bada58f051dc06594af6ba$var$win.requestAnimationFrame || $fd039c0bada58f051dc06594af6ba$var$win.webkitRequestAnimationFrame || $fd039c0bada58f051dc06594af6ba$var$win.mozRequestAnimationFrame || $fd039c0bada58f051dc06594af6ba$var$win.oRequestAnimationFrame || $fd039c0bada58f051dc06594af6ba$var$win.msRequestAnimationFrame || function (callback) {
  return $fd039c0bada58f051dc06594af6ba$var$win.setTimeout(callback, 1000 / 60);
};

const $fd039c0bada58f051dc06594af6ba$var$cancel = $fd039c0bada58f051dc06594af6ba$var$win.cancelAnimationFrame || $fd039c0bada58f051dc06594af6ba$var$win.webkitCancelAnimationFrame || $fd039c0bada58f051dc06594af6ba$var$win.mozCancelAnimationFrame || $fd039c0bada58f051dc06594af6ba$var$win.oCancelAnimationFrame || $fd039c0bada58f051dc06594af6ba$var$win.msCancelAnimationFrame || function (id) {
  $fd039c0bada58f051dc06594af6ba$var$win.clearTimeout(id);
};

const $fd039c0bada58f051dc06594af6ba$export$raf = $fd039c0bada58f051dc06594af6ba$var$request;
const $fd039c0bada58f051dc06594af6ba$export$caf = $fd039c0bada58f051dc06594af6ba$var$cancel;

const $d9cac488fcbfeca204fd79530e253cdc$export$cancelAnimationTimeout = frame => $fd039c0bada58f051dc06594af6ba$export$caf(frame.id);
/**
 * Recursively calls requestAnimationFrame until a specified delay has been met or exceeded.
 * When the delay time has been reached the function you're timing out will be called.
 *
 * Credit: Joe Lambert (https://gist.github.com/joelambert/1002116#file-requesttimeout-js)
 */


const $d9cac488fcbfeca204fd79530e253cdc$export$requestAnimationTimeout = (callback, delay) => {
  let start; // wait for end of processing current event handler, because event handler may be long

  Promise.resolve().then(() => {
    start = Date.now();
  });

  const timeout = () => {
    if (Date.now() - start >= delay) {
      callback();
    } else {
      frame.id = $fd039c0bada58f051dc06594af6ba$export$raf(timeout);
    }
  };

  const frame = {
    id: $fd039c0bada58f051dc06594af6ba$export$raf(timeout)
  };
  return frame;
};

class $c305ac887f13c8eb4baddf82e225e4bf$var$BaseHeightCache {
  constructor(props) {
    this.heights = void 0;
    this.DEFAULT_HEIGHT = void 0;
    const r = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {},
          t = r.DEFAULT_HEIGHT,
          n = void 0 === t ? 50 : t;
    this.heights = {};
    this.DEFAULT_HEIGHT = n;
  }

  get(r) {
    if (r in this.heights) return this.heights[r];
    return this.DEFAULT_HEIGHT;
  }

  set(r, t) {
    this.heights[r] = t;
  }

  getValidity(r) {
    return r in this.heights;
  }

}

class HeightCache extends $c305ac887f13c8eb4baddf82e225e4bf$var$BaseHeightCache {
  constructor(props) {
    super(props);
    this.validity = void 0;
    this.validity = {};
  }

  getValidity(r) {
    return !!this.validity[r];
  }

  hasAllValidity() {
    const v = Object.values(this.validity);
    console.log('v: ', v);
    return v.every(e => e) && v.length === Object.values(this.heights).length;
  }

  set(t, n) {
    super.set(t, n);
    this.validity[t] = true;
  }

  invalidate(r) {
    if (!r) {
      this.validity = {};
      return;
    }

    delete this.validity[r];
  }

}

exports.HeightCache = HeightCache;

class $a48c290d83c78eecaecba4cdeb8647bd$var$LayoutBase {
  constructor(props) {
    this.keys = void 0;
    this.heightCache = void 0;
    this.tops = void 0;
    this.totalHeight = void 0;
    const r = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {},
          a = r.keys,
          n = void 0 === a ? [] : a,
          s = r.heightCache,
          l = void 0 === s ? new HeightCache() : s;
    this.keys = n;
    this.heightCache = l;
    this.layout();
  }

  layout() {
    const r = this;
    const a = this.keys;
    const n = {};
    let t = 0;
    forEach(a, e => {
      n[e] = t;
      t += r.getHeight(e);
    });
    this.tops = n;
    this.totalHeight = t;
  }

  getHeight(r) {
    return this.heightCache.get(r);
  }

  getHeightValidity(r) {
    return this.heightCache.getValidity(r);
  }

  getTop(r) {
    return this.tops[r];
  }

  getBottom(r) {
    return this.tops[r] + this.getHeight(r);
  }

  getTops() {
    return this.tops;
  }

  getTotalHeight() {
    return this.totalHeight;
  }

  getOffsetForKey(r) {
    if (!r) return this.totalHeight;
    return this.getTop(r);
  }

  getBounds(r, a) {
    const n = this.keys;
    let t = 0;

    while (t + 1 < n.length) {
      const s = n[t + 1];
      const l = this.getTop(s);
      if (l > r) break;
      t += 1;
    }

    let o = t;

    while (o < n.length) {
      const i = n[o];
      const u = this.getTop(i);
      if (u > a) break;
      o += 1;
    }

    return {
      start: t,
      end: o
    };
  }

  setHeight(r, a, n) {
    this.heightCache.set(r, a);
    this.layout();
  }

  setKeys(r, n) {
    this.keys = r;
    this.layout();
  }

}

class Layout extends $a48c290d83c78eecaecba4cdeb8647bd$var$LayoutBase {
  constructor(props) {
    const e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {},
          a = e.keys,
          r = e.heightCache,
          i = e.containerHeight,
          s = void 0 === i ? 0 : i,
          o = e.stickToBottom,
          c = void 0 !== o && o,
          u = e.bottomMargin,
          d = void 0 === u ? 0 : u,
          p = e.ANCHOR_OFFSET,
          m = void 0 === p ? 0 : p,
          h = e.STICKY_EPSILON,
          f = void 0 === h ? 2 : h,
          v = e.STICKY_EPSILON_SETHEIGHT,
          b = void 0 === v ? 2 : v;
    super({
      keys: a,
      heightCache: r
    });
    this.containerHeight = void 0;
    this.stickToBottom = void 0;
    this.bottomMargin = void 0;
    this.ANCHOR_OFFSET = void 0;
    this.STICKY_EPSILON = void 0;
    this.STICKY_EPSILON_SETHEIGHT = void 0;
    this.anchorOffset = void 0;
    this.anchor = void 0;
    this.containerHeight = s;
    this.stickToBottom = c;
    this.bottomMargin = d;
    this.STICKY_EPSILON = f;
    this.STICKY_EPSILON_SETHEIGHT = b;
    this.ANCHOR_OFFSET = m;
    this.anchorOffset = m;
    this.anchor = false;
  }

  getOffsetForKey(t) {
    if (!t) return this.totalHeight;
    const a = this.getTop(t);
    if (void 0 === a) return 0;
    return a - (this.anchorOffset || 0);
  }

  setHeight(a, r, n) {
    if (false !== this.anchor) {
      super.setHeight(a, r);
      return this.bracketScrollTop(this.getOffsetForKey(this.anchor));
    }

    if (this.shouldStickToBottom(n, this.STICKY_EPSILON_SETHEIGHT)) {
      super.setHeight(a, r);
      return this.bracketScrollTop(Infinity);
    }

    let i = n;
    const s = this.getBottom(a);

    if (s <= n + this.anchorOffset) {
      const o = r - this.getHeight(a);
      i += o;
    }

    super.setHeight(a, r);
    return this.bracketScrollTop(i);
  }

  setKeys(a, r) {
    if (false !== this.anchor) {
      super.setKeys(a);
      return this.bracketScrollTop(this.getOffsetForKey(this.anchor));
    }

    if (this.shouldStickToBottom(r)) {
      super.setKeys(a);
      return this.bracketScrollTop(Infinity);
    }

    const n = r + this.anchorOffset;
    const i = this.findAnchor(this.keys, a, n);

    if (!i) {
      super.setKeys(a);
      return this.bracketScrollTop(r);
    }

    const s = this.getTop(i) - n;
    super.setKeys(a);
    const o = this.getTop(i) - n;
    const l = s - o;
    return this.bracketScrollTop(r - l);
  }

  setContainerHeight(t, a) {
    if (false !== this.anchor) {
      this.containerHeight = t;
      this.layout();
      return this.bracketScrollTop(this.getOffsetForKey(this.anchor));
    }

    if (this.shouldStickToBottom(a)) {
      this.containerHeight = t;
      this.layout();
      return this.bracketScrollTop(Infinity);
    }

    this.containerHeight = t;
    this.layout();
    return a;
  }

  setBottomMargin(t) {
    this.bottomMargin = t;
  }

  setStickToBottom(t) {
    this.stickToBottom = t;
  }

  setAnchor(t, a) {
    this.anchor = t;
    this.anchorOffset = 'number' !== typeof a ? this.ANCHOR_OFFSET : a;
  }

  findAnchor(t, a, r) {
    for (let n = 0; n < t.length; n++) {
      const i = t[n];
      if (this.getBottom(i) > r) for (let s = 0; s < a.length; s++) if (a[s] === i) return i;
    }

    return null;
  }

  bracketScrollTop(t) {
    return Math.max(0, Math.min(this.totalHeight - this.containerHeight + (this.bottomMargin || 0), t));
  }

  shouldStickToBottom(t, n) {
    const a = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : this.STICKY_EPSILON;
    if (!this.stickToBottom) return false;
    return t >= this.totalHeight - this.containerHeight - a + (this.bottomMargin || 0);
  }

}

exports.Layout = Layout;

const $bdbafe53f0196d0b4b19a532c1f9ee08$export$shallowEqual = (objA, objB) => {
  if (objA === objB) {
    return true;
  }

  if (typeof objA !== 'object' || objA === null || typeof objB !== 'object' || objB === null) {
    return false;
  }

  const keysA = Object.keys(objA);
  const keysB = Object.keys(objB);

  if (keysA.length !== keysB.length) {
    return false;
  } // Test for A's keys different from B.


  const bHasOwnProperty = Object.prototype.hasOwnProperty.bind(objB);

  for (let i = 0; i < keysA.length; i++) {
    if (!bHasOwnProperty(keysA[i]) || objA[keysA[i]] !== objB[keysA[i]]) {
      return false;
    }
  }

  return true;
};

class ListItem extends _react.Component {
  constructor(props) {
    super(props);
    this.mutationObserver = void 0;
    this.node = void 0;
    this.justFocused = void 0;
    this.focusTimerId = void 0;

    this.onFocusLeave = () => {
      this.props.onFocusLeave();
    };

    this.updateHeight = this.updateHeight.bind(this);
    this.setRef = this.setRef.bind(this);
    this.onFocusEnter = this.onFocusEnter.bind(this);
    this.onFocusWithin = this.onFocusWithin.bind(this);
    this.onFocusLeave = this.onFocusLeave.bind(this);
    this.onMouseEnter = this.onMouseEnter.bind(this);
    this.onMouseOver = this.onMouseOver.bind(this);
    this.onMouseLeave = this.onMouseLeave.bind(this);
    this.onMouseDown = this.onMouseDown.bind(this);
    this.onMouseUp = this.onMouseUp.bind(this);
    this.mutationObserver = new MutationObserver(this.updateHeight);
    this.node = null;
    this.justFocused = false;
  }

  componentDidMount() {
    if (this.node && this.mutationObserver) {
      this.mutationObserver.observe(this.node, {
        childList: true,
        subtree: true,
        attributes: true,
        characterData: true
      });
      this.node.addEventListener('load', this.updateHeight, true);
    }

    this.updateHeight();
    this.maybeFocusNode();
  }

  shouldComponentUpdate(nextProps) {
    if (!$bdbafe53f0196d0b4b19a532c1f9ee08$export$shallowEqual(nextProps.style, this.props.style)) return true;
    if (!$bdbafe53f0196d0b4b19a532c1f9ee08$export$shallowEqual(nextProps.children.props, this.props.children.props)) return true;
    if (nextProps.children.key !== this.props.children.key) return true;
    if (!nextProps.validity) return true; // if ( nextProps.hasFocus !== this.props.hasFocus ) return true;

    if (nextProps.isMouseDownOnItem !== this.props.isMouseDownOnItem) return true; // if ( nextProps.hasFocusWithin !== this.props.hasFocusWithin ) return true;

    return false;
  }

  componentDidUpdate() {
    this.updateHeight();
    this.maybeFocusNode();
  }

  componentWillUnmount() {
    if (this.mutationObserver) {
      this.mutationObserver.disconnect();
      this.mutationObserver = null;
    }
  }

  onFocusEnter(r) {
    const a = this;
    const n = r.relatedEvent;
    if (n && 'mousedown' === n.type) return;
    clearTimeout(this.focusTimerId);
    this.justFocused = true;
    this.focusTimerId = setTimeout(function () {
      a.justFocused = false;
    }, 250);
    this.props.onFocusEnter(Object.assign({
      id: this.props.id
    }, r));
  }

  onFocusWithin(r) {
    const a = this;
    const n = r.relatedEvent,
          s = r.target,
          l = r.currentTarget;
    if (n && 'mousedown' === n.type) return;

    if (s === l) {
      clearTimeout(this.focusTimerId);
      this.justFocused = true;
      this.focusTimerId = setTimeout(function () {
        a.justFocused = false;
      }, 250);
    }

    this.props.onFocusWithin(Object.assign({
      id: this.props.id
    }, r));
  }

  onMouseEnter(r) {
    if (this.justFocused) return;
    const a = Object.assign({
      id: this.props.id
    }, r);
    this.props.onMouseEnter(a);
  }

  onMouseOver(r) {
    if (this.justFocused) return;
    this.props.onMouseOver(Object.assign({
      id: this.props.id
    }, r));
  }

  onMouseLeave(r) {
    this.props.onMouseLeave(Object.assign({
      id: this.props.id
    }, r));
  }

  onMouseDown(r) {
    this.props.onMouseDown(Object.assign({
      id: this.props.id
    }, r));
  }

  onMouseUp(r) {
    this.props.onMouseUp(Object.assign({
      id: this.props.id
    }, r));
  }

  setRef(r) {
    this.node = r;
  }

  updateHeight() {
    if (!this.node) return;
    const r = this.node.getBoundingClientRect(),
          a = r.height;
    const needUpdate = Math.abs(a - (this.props.height || 0)) > 0.5 || !this.props.validity;

    if (needUpdate) {
      this.props.onHeightChange(this.props.id, a);
    }
  }

  maybeFocusNode() {
    this.props.hasFocus && this.node && this.node.focus();
  }

  determineTabIndex() {
    if (this.props.isMouseDownOnItem) return;
    if (this.props.hasFocusWithin) return 0;
    return -1;
  }

  render() {
    if (!this.props.children) return null;

    const rootClass = _classnames(_ladifireCssSassIndexScss.position__absolute, _ladifireCssSassIndexScss.width__100_percent, _ladifireCssSassIndexScss.pseudo_focus__outline_none, {
      [_ladifireCssSassIndexScss.width__auto]: this.props.shouldHorizontallyScroll
    }, this.props.className); // const rootClass = classNames(
    //   'c_virtual_list__item',
    //   {
    //     'c_virtual_list__item__focus': this.props.hasFocus,
    //     'c_virtual_list__item__auto_width': this.props.shouldHorizontallyScroll,
    //   },
    //   this.props.className
    // );


    return /*#__PURE__*/_react.createElement("div", {
      role: this.props.role,
      ref: this.setRef,
      style: this.props.style,
      "aria-label": this.props.ariaLabel,
      "aria-expanded": this.props.ariaExpanded // onMouseEnter={ this.onMouseEnter }
      // onMouseOver={ this.onMouseOver }
      // onMouseLeave={ this.onMouseLeave }
      ,
      onMouseDown: this.onMouseDown,
      onMouseUp: this.onMouseUp,
      className: rootClass,
      tabIndex: this.determineTabIndex()
    }, this.props.children); // return (
    //   <FocusManager
    //     onFocusEnter={ this.onFocusEnter }
    //     onFocusWithin={ this.onFocusWithin }
    //     onFocusLeave={ this.onFocusLeave }
    //   >
    //     <div
    //       role={ this.props.role }
    //       ref={ this.setRef }
    //       style={ this.props.style }
    //       aria-label={ this.props.ariaLabel }
    //       aria-expanded={ this.props.ariaExpanded }
    //       onMouseEnter={ this.onMouseEnter }
    //       onMouseOver={ this.onMouseOver }
    //       onMouseLeave={ this.onMouseLeave }
    //       onMouseDown={ this.onMouseDown }
    //       onMouseUp={ this.onMouseUp }
    //       className={ rootClass }
    //       tabIndex={ this.determineTabIndex() }
    //     >
    //       { this.props.children }
    //     </div>
    //   </FocusManager>
    // );
  }

}

exports.ListItem = ListItem;
ListItem.displayName = 'ListItem';
ListItem.defaultProps = {
  ariaLabel: undefined,
  children: undefined,
  onFocusEnter: noop,
  onFocusWithin: noop,
  onFocusLeave: noop,
  onHeightChange: noop,
  onMouseEnter: noop,
  onMouseOver: noop,
  onMouseLeave: noop,
  onMouseDown: noop,
  onMouseUp: noop,
  className: '',
  style: {},
  role: 'listitem',
  height: undefined,
  validity: true,
  hasFocus: false,
  hasFocusWithin: false,
  isMouseDownOnItem: false,
  shouldHorizontallyScroll: false
};

class $d0c246e60786ebfbc1aa04777b9f6b8$export$default extends _react.PureComponent {
  render() {
    const {
      onScroll,
      width,
      role
    } = this.props;
    return /*#__PURE__*/_react.createElement("div", {
      onScroll: onScroll,
      role: role,
      className: "c_scrollbar__child",
      style: {
        width: width
      }
    }, this.props.children);
  }

}

$d0c246e60786ebfbc1aa04777b9f6b8$export$default.displayName = 'Content';
$d0c246e60786ebfbc1aa04777b9f6b8$export$default.defaultProps = {
  children: null,
  role: 'presentation',
  onScroll: noop
};

const $a13610e4db3372a14df46b274bdbeea7$var$E = function e(r) {
  return r.stopPropagation();
};

class Scrollbar extends _react.PureComponent {
  // static propTypes = {
  //   children: PropTypes.node,
  //   width: PropTypes.number.isRequired,
  //   height: PropTypes.number.isRequired,
  //   contentHeight: PropTypes.number,
  //   color: PropTypes.string,
  //   className: PropTypes.string,
  //   monkey: PropTypes.bool,
  //   fade: PropTypes.bool,
  //   anchor: PropTypes.oneOf( [ 'top', 'bottom' ] ),
  //   role: PropTypes.string,
  //   ariaLabel: PropTypes.string,
  //   onScroll: PropTypes.func,
  //   onContentScroll: PropTypes.func,
  //   onTrackClick: PropTypes.func,
  //   initialScrollTop: PropTypes.number,
  // };
  constructor(props) {
    super(props);
    this.scroller = void 0;
    this.currentScrollTop = void 0;
    this.dragging = void 0;
    this.delta = void 0;
    this.trackInterval = void 0;
    this.trackTimeout = void 0;
    this.trackAnimation = void 0;
    this.track = void 0;

    this.onDragStart = e => {
      e.preventDefault();
      e.stopPropagation();
      const a = this.getScrollHeight();
      const n = this.getTrackHeight();
      this.dragging = true;
      this.delta.y = e.clientY;
      this.delta.top = 'top' === this.props.anchor ? this.currentScrollTop : a - this.currentScrollTop;
      this.delta.speed = a / n;
      document.addEventListener('mousemove', this.onDrag);
      document.addEventListener('mouseup', this.onDragEnd);
      document.addEventListener('mouseleave', this.onDragEnd);
    };

    this.onDragEnd = () => {
      this.dragging = false;
      document.removeEventListener('mousemove', this.onDrag);
      document.removeEventListener('mouseup', this.onDragEnd);
      document.removeEventListener('mouseleave', this.onDragEnd);
    };

    this.onDrag = e => {
      e.preventDefault();
      e.stopPropagation();
      const a = e.clientY;
      const n = this.getScrollHeight();
      const t = (a - (this.delta.y || 0)) * (this.delta.speed || 1);
      const s = 'top' === this.props.anchor ? (this.delta.top || 0) + t : n - ((this.delta.top || 0) - t);
      this.scrollTop(s);
    };

    this.onTrackDown = a => {
      console.log('track down');
      const n = this;
      a.preventDefault();
      a.stopPropagation();
      const t = this.props.onTrackClick || this.track.to;
      const s = a.nativeEvent.offsetY;

      const l = function e() {
        if (s >= n.state.top && s <= n.state.top + n.state.height) {
          clearInterval(n.trackInterval);
          return;
        }

        const r = t({
          y: s,
          scrollTop: n.currentScrollTop,
          scrollHeight: n.getScrollHeight(),
          trackHeight: n.getTrackHeight(),
          barTop: n.state.top,
          barHeight: n.state.height
        });
        n.scrollWithAnimation(r);
      };

      l();
      clearInterval(this.trackInterval);
      clearTimeout(this.trackTimeout);
      this.trackTimeout = setTimeout(function () {
        l();
        n.trackInterval = setInterval(l, 200);
      }, 500);
      window.addEventListener('mouseup', this.onTrackUp);
    };

    this.onTrackUp = () => {
      this.trackAnimation && this.trackAnimation.cancel();
      clearInterval(this.trackInterval);
      clearTimeout(this.trackTimeout);
      window.removeEventListener('mouseup', this.onTrackUp);
    };

    this.getScrollHeight = () => {
      const r = this.props.contentHeight;
      return 'undefined' !== typeof r ? r : this.scroller.scrollHeight;
    };

    this.getTrackHeight = () => {
      return this.track && this.track.offsetHeight;
    };

    this.scrollWithAnimation = r => {// console.log("rr", r);
      // var t = this;
      // var n = 0;
      // var a = function e( rr ) {
      // 	var a = rr.value,
      // 		s = rr.nextTick;
      //
      // 	var l = t.scroller.scrollTop + a + n;
      // 	var i = Math.round( l );
      // 	n = l - i;
      // 	t.scrollTop( i );
      // 	// s();
      // };
      // this.trackAnimation && this.trackAnimation.cancel();
      // this.trackAnimation = Animate( {
      // 	fromValue: this.scroller.scrollTop,
      // 	toValue: r,
      // 	duration: 200,
      // 	delta: true,
      //   onUpdate: a,
      // } );
      // return this.trackAnimation;
    };

    this.update = () => {
      if (!this.scroller) return;
      const r = this.props.height;
      const t = this.currentScrollTop;
      const n = this.getScrollHeight();
      let a = this.getBarHeight(n);
      a = a < 50 ? 50 : a;
      const s = t / (n - r) * (this.getTrackHeight() - a);
      const l = n <= r;
      this.setState({
        height: a,
        top: s,
        hidden: l
      });
    };

    this.scroller = null;
    this.currentScrollTop = props.initialScrollTop || 0;
    this.dragging = false;
    this.delta = {
      y: undefined,
      top: undefined,
      speed: undefined
    };
    this.trackInterval = void 0;
    this.trackTimeout = void 0;
    this.trackAnimation = void 0;
    this.onScroll = this.onScroll.bind(this);
    this.onDragStart = this.onDragStart.bind(this);
    this.onDragEnd = this.onDragEnd.bind(this);
    this.onDrag = this.onDrag.bind(this);
    this.onTrackDown = this.onTrackDown.bind(this);
    this.onTrackUp = this.onTrackUp.bind(this);
    this.setRef = this.setRef.bind(this);
    this.setTrackRef = this.setTrackRef.bind(this);
    this.state = {
      height: 0,
      top: 0,
      hidden: props.fade
    };
  }

  componentDidMount() {
    this.props.initialScrollTop && (this.scroller.scrollTop = this.props.initialScrollTop);
    this.update();
  }

  componentDidUpdate() {
    this.update();
  }

  componentWillUnmount() {
    this.trackAnimation && this.trackAnimation.cancel();
    clearInterval(this.trackInterval);
    clearTimeout(this.trackTimeout);
    window.removeEventListener('mouseup', this.onTrackUp);
  }

  onScroll(r) {
    if (!this.scroller) return;
    const t = this.scroller.scrollTop;
    if (t && t === this.currentScrollTop) return;
    this.currentScrollTop = t;
    this.update();
    this.props.onScroll && this.props.onScroll(r, {
      scrollTop: this.currentScrollTop
    });
  }

  setRef(scroller) {
    this.scroller = scroller;
  }

  setTrackRef(track) {
    this.track = track;
  }

  getBarHeight(n) {
    const r = this.getScrollHeight();
    const t = this.props.height;
    if (0 === r) return 0;
    return t / r * t;
  }

  scrollTop(r) {
    if (!this.scroller) return null;

    if (void 0 !== r) {
      this.scroller.scrollTop = r;
      return this.scroller.scrollTop;
    }

    return this.currentScrollTop;
  }

  render() {
    const {
      width,
      height,
      contentHeight,
      isEmpty
    } = this.props;

    const _rootClasses = _classnames(_ladifireCssSassIndexScss.c_scrollbar, _ladifireCssSassIndexScss.position__relative, _ladifireCssSassIndexScss.overflow_y__hidden, _ladifireCssSassIndexScss.overflow_x__hidden, _ladifireCssSassComponentsScrollbarScss.scrollbar__fade, this.props.className);

    return /*#__PURE__*/_react.createElement("div", {
      className: _rootClasses,
      style: {
        width: width,
        height: height
      },
      "aria-label": this.props.ariaLabel,
      onKeyDown: this.props.onKeyDown
    }, /*#__PURE__*/_react.createElement("div", {
      role: 'presentation',
      className: _classnames(_ladifireCssSassIndexScss.c_scrollbar__hider, _ladifireCssSassIndexScss.overflow_y__auto, _ladifireCssSassIndexScss.overflow_x__hidden, _ladifireCssSassIndexScss.outline__none, _ladifireCssSassIndexScss.position__absolute, _ladifireCssSassIndexScss.top__0, _ladifireCssSassIndexScss.left__0, _ladifireCssSassIndexScss.bottom__0, _ladifireCssSassIndexScss.right__50m, _ladifireCssSassIndexScss.width__100_percent, _ladifireCssSassIndexScss.height__100_percent, _ladifireCssSassIndexScss.transform__translateZ0, _ladifireCssSassIndexScss.pseudo_webkit_scrollbar__none),
      onScroll: this.onScroll,
      ref: this.setRef
    }, /*#__PURE__*/_react.createElement($d0c246e60786ebfbc1aa04777b9f6b8$export$default, {
      width: width,
      role: 'presentation',
      onScroll: this.props.onContentScroll
    }, this.props.children)), /*#__PURE__*/_react.createElement("div", {
      role: 'presentation',
      className: _classnames(_ladifireCssSassIndexScss.c_scrollbar__track, _ladifireCssSassIndexScss.position__absolute, _ladifireCssSassIndexScss.right__2, _ladifireCssSassIndexScss.top__0, _ladifireCssSassIndexScss.bottom__0, _ladifireCssSassIndexScss.width__8, _ladifireCssSassIndexScss.opacity__1, _ladifireCssSassIndexScss.c_scrollbar__track),
      onMouseDown: this.onTrackDown,
      onMouseUp: this.onTrackUp,
      ref: this.setTrackRef
    }, /*#__PURE__*/_react.createElement("div", {
      role: 'presentation',
      className: _classnames(_ladifireCssSassIndexScss.c_scrollbar__bar, _ladifireCssSassIndexScss.position__absolute, _ladifireCssSassIndexScss.top__0, _ladifireCssSassIndexScss.left__0, _ladifireCssSassIndexScss.width__100_percent, _ladifireCssSassIndexScss.border_radius__4, _ladifireCssSassIndexScss.opacity__0, _ladifireCssSassIndexScss.cursor__default, _ladifireCssSassIndexScss.outline__none, _ladifireCssSassIndexScss.z_index__1, _ladifireCssSassIndexScss.will_change__transform, _ladifireCssSassComponentsScrollbarScss.scrollbar__bar, _ladifireCssSassIndexScss.background__black_alpha_40, {
        [_ladifireCssSassIndexScss.opacity__0]: this.state.hidden
      }),
      style: {
        height: this.state.height,
        transform: 'translateY(' + Math.floor(this.state.top) + 'px)',
        background: this.props.color,
        opacity: (isEmpty || contentHeight <= height) && 0
      },
      onMouseDown: this.onDragStart,
      onClick: $a13610e4db3372a14df46b274bdbeea7$var$E,
      tabIndex: -1
    })));
  }

}

exports.Scrollbar = Scrollbar;
Scrollbar.displayName = 'Scrollbar';
Scrollbar.defaultProps = {
  children: undefined,
  style: undefined,
  contentHeight: undefined,
  color: undefined,
  className: undefined,
  monkey: false,
  fade: false,
  anchor: 'top',
  role: 'presentation',
  ariaLabel: undefined,
  onScroll: undefined,
  onContentScroll: noop,
  onTrackClick: undefined,
  initialScrollTop: 0
};
Scrollbar.track = {
  to: function e(r) {
    const a = r.y,
          n = r.scrollTop,
          t = r.scrollHeight,
          s = r.trackHeight,
          l = r.barTop,
          o = r.barHeight;
    const i = a - l - o / 2;
    return n + i * (t / s);
  },
  page: function e(r) {
    const a = r.y,
          n = r.scrollTop,
          t = r.trackHeight,
          s = r.barTop;
    return a < s ? n - (t - 21) : n + (t - 21);
  }
};

class List extends _react.PureComponent {
  constructor(_e) {
    super(_e);
    this.layout = void 0;
    this.node = void 0;
    this.contentNode = void 0;
    this.isSelecting = void 0;
    this.selectionStart = void 0;
    this.selectionEnd = void 0;
    this.scrollStartTimeout = void 0;
    this._disablePointerEventsTimeoutId = void 0;
    this.scrollTop = void 0;

    this._debounceScrollEndedCallback = () => {
      if (this.props.onScrollEnd) {
        this.props.onScrollEnd();
      }

      this._disablePointerEventsTimeoutId = null; // isScrolling is used to determine if we reset styleCache

      this.setState(function (e) {
        if (!e.scrolling) return null;
        return {
          scrolling: false
        };
      });
    };

    this._handleWindowScroll = () => {// console.log('_handleWindowScroll:');
    };

    this.onScroll = this.onScroll.bind(this);
    this.onContentScroll = this.onContentScroll.bind(this);
    this.onSelectionChange = this.onSelectionChange.bind(this);
    this.setRef = this.setRef.bind(this);
    this.setContentRef = this.setContentRef.bind(this);
    this.setHeight = this.setHeight.bind(this);
    this.getScrollTop = this.getScrollTop.bind(this);
    this.getVisibleRange = this.getVisibleRange.bind(this);
    this.isItemInView = this.isItemInView.bind(this);
    this.layout = _e ? _e.layout : new Layout();
    this.node = null;
    this.contentNode = null;
    this.isSelecting = false;
    this.selectionStart = null;
    this.selectionEnd = null;
    this.scrollStartTimeout = null;
    this._disablePointerEventsTimeoutId = null;
    _e && _e.keys && this.layout.setKeys(_e.keys);
    const n = this.getBounds(0, _e ? _e.height : 0),
          s = n.start,
          l = n.end;
    const i = this.layout.getTops();
    this.state = {
      start: s,
      end: l,
      tops: i,
      scrolling: false
    };
  }

  componentDidMount() {
    document.addEventListener('selectionchange', this.onSelectionChange);
  }

  UNSAFE_componentWillReceiveProps(r) {
    r.width !== this.props.width && this.layout.heightCache.invalidate();
    isEqual(this.props.keys, r.keys) || this.layout.setKeys(r.keys);
    this.relayout();
  }

  componentWillUnmount() {
    if (this._disablePointerEventsTimeoutId) {
      $d9cac488fcbfeca204fd79530e253cdc$export$cancelAnimationTimeout(this._disablePointerEventsTimeoutId);
    }

    document.removeEventListener('selectionchange', this.onSelectionChange);
  }
  /**
   * Sets an :isScrolling flag for a small window of time.
   * This flag is used to disable pointer events on the scrollable portion of the Grid.
   * This prevents jerky/stuttery mouse-wheel scrolling.
   */


  _debounceScrollEnded() {
    const scrollingResetTimeInterval = 150; // {scrollingResetTimeInterval} = this.props || 50;

    if (this._disablePointerEventsTimeoutId) {
      $d9cac488fcbfeca204fd79530e253cdc$export$cancelAnimationTimeout(this._disablePointerEventsTimeoutId);
    }

    this._disablePointerEventsTimeoutId = $d9cac488fcbfeca204fd79530e253cdc$export$requestAnimationTimeout(this._debounceScrollEndedCallback, scrollingResetTimeInterval);
  }

  onScroll(r, x) {
    this._debounceScrollEnded();

    this.setState(function () {
      return {
        scrolling: true
      };
    });
    this.relayout();
    this.props.onScroll(r, {
      scrollTop: this.getScrollTop(),
      scrollHeight: this.getContentHeight(),
      clientHeight: this.props.height
    });
  }

  onContentScroll(r) {
    this.props.onContentScroll(r);
  }

  onSelectionChange() {
    if (!this.node) return;

    if ( // @ts-ignore
    'Range' === window.getSelection().type && this.contentNode && // @ts-ignore
    this.contentNode.contains(window.getSelection().anchorNode)) {
      this.isSelecting = true;
      this.selectionStart = this.props.keys[this.state.start];
      this.selectionEnd = this.props.keys[this.state.end - 1];
    } else {
      this.isSelecting = false;
      this.selectionStart = null;
      this.selectionEnd = null;
    }

    this.props.onSelectionChange(this.isSelecting);
  }

  setRef(r) {
    this.node = r;
  }

  setContentRef(r) {
    this.contentNode = r;
  }

  getTop(r) {
    return this.layout.getTop(r);
  }

  getBottom(r) {
    return this.layout.getBottom(r);
  }

  getScrollTop() {
    if (!this.props.useWindowScroller && !this.node) return null;
    return this.props.useWindowScroller ? this.props.scrollTop : this.node.scrollTop();
  }

  setHeight(r, t) {
    if (!r) return;
    if (Math.abs(t - this.layout.getHeight(r)) < 0.5) return;
    this.layout.setHeight(r, t);
    this.relayout();
  }

  setScrollTop(r) {
    if (!this.node) return;
    this.node.scrollTop(Math.ceil(r));
  }

  getClassName() {
    return _classnames('c_virtual_list', _ladifireCssSassIndexScss.overflow_x__hidden, _ladifireCssSassIndexScss.overflow_y__hidden, this.props.className);
  }

  getContentsClassName() {
    return _classnames('c_virtual_list__scroll_container', {
      [_ladifireCssSassIndexScss.pointer_event__none]: this.isScrolling() && !this.isSelecting
    });
  }

  getVisibleRange() {
    const r = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : this.getScrollTop();
    const t = this.props,
          n = t.keys,
          a = t.height;
    const s = this.layout.getBounds(r, r + a),
          l = s.start,
          i = s.end;
    const o = this.layout.getTop(n[l]) < r - 1 ? l + 1 : l;
    const u = this.layout.getBottom(n[i - 1]) > r + a + 1 ? i - 1 : i;
    const c = Math.min(o, n.length - 1);
    const d = Math.max(u, c);
    return {
      start: c,
      end: d
    };
  }

  getContentHeight() {
    return this.layout.getTotalHeight();
  }

  getContainerHeight() {
    return this.props.height;
  }

  getBounds(r, t) {
    // this.onSelectionChange();
    let n = r;
    let a = t;
    this.selectionStart && (n = Math.min(n, this.layout.getTop(this.selectionStart)));
    this.selectionEnd && (a = Math.max(a, this.layout.getBottom(this.selectionEnd)));
    return this.layout.getBounds(n, a);
  }

  isScrolling() {
    return this.props.useWindowScroller ? this.props.isScrolling : this.state.scrolling;
  }

  isItemInView(r) {
    const t = this.getScrollTop();
    const n = this.layout.getTop(r);
    return n >= t && n <= t + this.props.height;
  }

  isScrolledToTop() {
    return Math.floor(this.getScrollTop()) <= 1;
  }

  isScrolledToBottom() {
    return this.getScrollTop() + this.getContainerHeight() >= this.layout.getTotalHeight() - 1;
  }

  scrollToKey(r, x) {
    const t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {},
          n = t.lazy,
          a = t.animate;
    if (n && this.isItemInView(r)) return;
    const s = this.layout.getOffsetForKey(r);
    this.scrollToOffset(s, {
      animate: a
    });
  }

  scrollToOffset(r, x) {
    const t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {},
          n = t.animate;
    if (!this.node) return;
    const a = this.bracketScrollTop(r);

    if (n) {
      this.node.scrollWithAnimation(a);
      return;
    }

    this.scrollTop = a;
    this.setScrollTop(a);
  }

  bracketScrollTop(r) {
    return Math.max(0, Math.min(this.getContentHeight() - this.props.height, r));
  }

  relayout() {
    var r = this;
    this.setState(function (e, t) {
      var n = r.getScrollTop();
      var a = t.height / 2;
      var s = n - a;
      var l = n + t.height + a;
      var i = r.getBounds(s, l),
          o = i.start,
          u = i.end;
      var c = r.layout.getTops();
      if (o === e.start && u === e.end && c === e.tops) return null;
      return {
        start: o,
        end: u,
        tops: c
      };
    });
  }

  renderItem(t, r) {
    const n = this.getTop(r);
    const a = this.layout.getHeight(r);
    const s = this.layout.getHeightValidity(r);
    const l = this.props.getAriaLabelForRow;
    const i = l && l(t);
    return /*#__PURE__*/_react.createElement(ListItem, {
      id: r,
      key: r,
      height: a,
      style: {
        top: n
      },
      role: this.props.itemRole,
      onHeightChange: this.setHeight,
      validity: s,
      ariaLabel: i,
      shouldHorizontallyScroll: this.props.shouldHorizontallyScroll
    }, this.props.rowRenderer(t));
  }

  renderItems() {
    const r = this;
    const t = this.props,
          n = t.keys,
          a = t.persistentKeys;
    const s = this.state,
          l = s.start,
          i = s.end;
    const o = [];

    for (let u = l; u < i; u++) {
      const c = n[u];
      c && o.push(this.renderItem(c, u));
    }

    a && a.forEach(function (e) {
      const tt = n.indexOf(e);
      if (tt < 0) return;
      if (tt >= l && tt < i) return;
      o.push(r.renderItem(e, tt));
    });
    return o;
  }

  renderContents() {
    const r = this.getContentsClassName();
    const t = this.getContentHeight();
    const n = this.renderItems();
    return /*#__PURE__*/_react.createElement("div", {
      ref: this.setContentRef,
      className: r,
      role: "presentation",
      style: {
        position: 'relative',
        height: t
      }
    }, n);
  }

  render() {
    const r = this.props,
          t = r.width,
          n = r.height;
    if (!this.props.useWindowScroller && (0 === t || 0 === n)) return null;
    const a = this.getClassName();
    const s = this.renderContents();

    if (this.props.useWindowScroller) {
      return /*#__PURE__*/_react.createElement("div", null, s);
    }

    return /*#__PURE__*/_react.createElement(Scrollbar, {
      className: a,
      width: t,
      height: this.getContainerHeight(),
      contentHeight: this.getContentHeight(),
      onTrackClick: Scrollbar.track.page,
      onScroll: this.onScroll,
      onContentScroll: this.onContentScroll,
      anchor: "top",
      role: this.props.role,
      ref: this.setRef,
      ariaLabel: this.props.ariaLabel,
      fade: this.props.fadeScrollbar,
      onKeyDown: this.props.onKeyDown,
      isEmpty: !this.props.keys || this.props.keys.length === 0
    }, s);
  }

}

exports.List = List;
List.defaultProps = {
  className: '',
  layout: void 0,
  role: 'list',
  itemRole: 'listitem',
  ariaLabel: undefined,
  persistentKeys: [],
  fadeScrollbar: false,
  onScroll: noop,
  onScrollEnd: noop,
  onContentScroll: noop,
  onSelectionChange: noop,
  getAriaLabelForRow: void 0,
  shouldHorizontallyScroll: false
};

class FocusManager extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.blurTimeoutId = void 0;
    this.hasFocus = void 0;
    this.relatedTarget = void 0;
    this.relatedEvent = void 0;
    this.onFocus = this.onFocus.bind(this);
    this.onBlur = this.onBlur.bind(this);
    this.blurTimeoutId = undefined;
    this.hasFocus = false;
  }

  componentWillMount() {
    const a = _react.Children.only(this.props.children);

    'function' === typeof a && this.checkChildIsValid(a); // if (0 === this.instances) {
    // 	if (Object(p["a"])()) document.addEventListener("blur", A, true);
    // 	else {
    // 		j();
    // 		y ? document.addEventListener("focusin", C, false) : document.addEventListener("focus", C, true)
    // 	}
    // 		document.addEventListener("focusin", I, false);
    // 		document.addEventListener("focusout", I, false)
    // 	}
    // 	document.addEventListener("keydown", S, true);
    // 	document.addEventListener("mousedown", T, true)
    // }

    FocusManager.instances += 1;
  }

  componentWillUnmount() {
    if (0 === FocusManager.instances) {}

    FocusManager.instances -= 1;
    this.blurTimeoutId && clearTimeout(this.blurTimeoutId);
  }

  onFocus(t) {
    const n = this.hasFocus ? this.props.onFocusWithin : this.props.onFocusEnter;
    this.hasFocus = true;
    const a = t.currentTarget,
          s = t.target;
    const l = t.relatedTarget || this.relatedTarget;
    n && n({
      relatedTarget: l,
      currentTarget: a,
      target: s,
      relatedEvent: this.relatedEvent
    });
  }

  onBlur(t) {
    const n = this;
    const a = t.currentTarget,
          s = t.target;
    const l = t.relatedTarget || this.relatedTarget;
    const i = {
      relatedTarget: l,
      currentTarget: a,
      target: s
    };

    if (!l) {
      this.handleBlur(i);
      return;
    }

    this.blurTimeoutId = setTimeout(function () {
      n.blurTimeoutId = undefined;
      a && !a.contains(l) && n.handleBlur(i);
    }, 150);
  }

  checkChildIsValid(r) {
    const t = r.props,
          n = t.onFocus,
          a = t.onBlur;
    const s = !!n && !!a;
    if (s) return;
    throw new Error('FocusManager requires a single child with onFocus and onBlur props.');
  }

  handleBlur(r) {
    if (!this.hasFocus) return;
    this.hasFocus = false;
    this.props.onFocusLeave && this.props.onFocusLeave(r);
  }

  render() {
    return /*#__PURE__*/_react.cloneElement(this.props.children, {
      onFocus: this.onFocus,
      onBlur: this.onBlur
    }, this.props.children.props.children);
  }

}

exports.FocusManager = FocusManager;
FocusManager.displayName = 'FocusManager';
FocusManager.defaultProps = {
  children: null,
  onFocusEnter: noop,
  onFocusWithin: noop,
  onFocusLeave: noop
};
FocusManager.instances = 0;

class KeyboardNavigableList extends List {
  constructor(props) {
    super(props);
    this.focusTimerId = void 0;
    this.keyCommands = void 0;
    this.isHomeKeyPressed = void 0;
    this.isEndKeyPressed = void 0;
    this.firstHiddenTabStop = void 0;
    this.lastHiddenTabStop = void 0;
    this.lastMouseCoords = void 0;

    this.onItemFocusWithin = r => {
      const t = r.id,
            a = r.relatedEvent,
            n = r.currentTarget,
            s = r.target;
      const l = a && 'keydown' === a.type;
      const i = l && a.shiftKey && n === s && !this.state.activeItem && this.state.initialActiveItem === t;

      if (i) {
        this.setActiveItem(t);
        return;
      }

      l && this.setState(function () {
        return {
          activeItem: null,
          initialActiveItem: t,
          hasKeyboardFocus: true
        };
      });
    };

    this.onFocusEnter = this.onFocusEnter.bind(this);
    this.onFocusLeave = this.onFocusLeave.bind(this);
    this.onItemMouseOver = this.onItemMouseOver.bind(this);
    this.onItemFocusEnter = this.onItemFocusEnter.bind(this);
    this.onItemFocusWithin = this.onItemFocusWithin.bind(this);
    this.onItemMouseLeave = this.onItemMouseLeave.bind(this);
    this.onItemMouseDown = this.onItemMouseDown.bind(this);
    this.onItemMouseUp = this.onItemMouseUp.bind(this);
    this.onMouseInterceptorMouseMove = this.onMouseInterceptorMouseMove.bind(this);
    this.moveFocusIntoVisibleScrollRegion = this.moveFocusIntoVisibleScrollRegion.bind(this);
    this.setFirstHiddenTabStopRef = this.setFirstHiddenTabStopRef.bind(this);
    this.setLastHiddenTabStopRef = this.setLastHiddenTabStopRef.bind(this);
    this.state = Object.assign({}, this.state, {
      initialActiveItem: undefined,
      activeItem: null,
      hasKeyboardFocus: false,
      hoveredItem: null,
      mouseDownTargetItem: null
    });
  }

  UNSAFE_componentWillReceiveProps(nextProps, nextState) {
    super.UNSAFE_componentWillReceiveProps(nextProps); //?

    this.possiblySetInitialFocus(nextProps);
    this.possiblyUpdateInitialActiveItem(nextProps);
  }

  possiblySetInitialFocus(r) {
    if (this.state.hasKeyboardFocus) return;
    const t = r.itemToFocus;

    if (t && this.isItemInView(t)) {
      this.setActiveItem(t);
      return;
    }

    t && t.length > 0 && this.setState(function () {
      return {
        initialActiveItem: t,
        setFocusOnScrollEnd: true
      };
    });
  }

  possiblyUpdateInitialActiveItem(r) {
    if (this.state.hasKeyboardFocus) return;
    if (r.initialActiveItem === this.state.initialActiveItem) return;
    this.setState(function () {
      return {
        initialActiveItem: r.initialActiveItem
      };
    });
  }

  componentDidMount() {
    super.componentDidMount(); //?

    const t = false; // this.props.shouldIgnoreScrollKeys.bind( this );

    const a = [{
      keys: ['pageup'],
      handler: this.onPageUp.bind(this),
      filter: t
    }, {
      keys: ['shift+space'],
      ignoreInputs: true,
      handler: this.onPageUp.bind(this),
      filter: t
    }, {
      keys: ['pagedown'],
      handler: this.onPageDown.bind(this),
      filter: t
    }, {
      keys: ['space'],
      ignoreInputs: true,
      handler: this.onPageDown.bind(this),
      filter: t
    }, {
      keys: ['home'],
      handler: this.onKeyDownHome.bind(this),
      action: 'keydown',
      filter: t
    }, {
      keys: ['end'],
      handler: this.onKeyDownEnd.bind(this),
      action: 'keydown',
      filter: t
    }, {
      keys: ['home'],
      handler: this.onKeyUpHome.bind(this),
      action: 'keyup'
    }, {
      keys: ['end'],
      handler: this.onKeyUpEnd.bind(this),
      action: 'keyup'
    }, {
      keys: ['up', 'down'],
      handler: this.onArrowKeyDown.bind(this),
      ignoreInputs: true,
      filter: false // this.props.shouldIgnoreArrowKeys.bind( this ),

    }, {
      keys: ['tab', 'shift+tab'],
      handler: this.onTabKeyDown.bind(this),
      ignoreInputs: true
    }];
    const n = this.props.keyCommands ? a.concat(this.props.keyCommands) : a;
    this.keyCommands = new _KeyCommands();
    this.keyCommands.bindAll(n);
  }

  componentWillUnmount() {
    this.keyCommands && this.keyCommands.reset();
    this.keyCommands = null;
    this.focusTimerId && clearTimeout(this.focusTimerId);
  }

  componentDidUpdate() {// this.state.hasKeyboardFocus && ! this.isScrolling() && this.updateTabIndexes();
  }

  onScrollEnd() {
    const t = this.state.hasKeyboardFocus;
    t && !this.isScrolling() && this.updateTabIndexes(); // TODO: check this
    // super.onScrollEnd();

    t && this.state.setFocusOnScrollEnd && this.moveFocusOnScrollEnd();
  }

  onScrollKeyDown(r) {// var t = r.keyCode;
    // if (!this.state.hasKeyboardFocus) return;
    // if ((t === y["e"] || t === y["h"]) && this.isScrolledToTop()) {
    // 	this.focusFirstItem();
    // 	return
    // }
    // if ((t === y["b"] || t === y["g"]) && this.isScrolledToBottom()) {
    // 	this.focusLastItem();
    // 	return
    // }
    // var a = C[t];
    // this.setState(function () {
    // 	return {
    // 		initialActiveItem: a,
    // 		setFocusOnScrollEnd: true
    // 	}
    // })
  }

  onPageUp(r) {
    this.onScrollKeyDown(r);

    if (this.props.onPageUp) {
      r.preventDefault();
      this.props.onPageUp(r);
    }
  }

  onPageDown(r) {
    this.onScrollKeyDown(r);

    if (this.props.onPageDown) {
      r.preventDefault();
      this.props.onPageDown(r);
    }
  }

  onKeyDownHome(r) {
    if (this.isHomeKeyPressed) return;
    this.isHomeKeyPressed = true;
    this.onScrollKeyDown(r);

    if (this.props.onHome) {
      r.preventDefault();
      this.props.onHome(r);
    }
  }

  onKeyDownEnd(r) {
    if (this.isEndKeyPressed) return;
    this.isEndKeyPressed = true;
    this.onScrollKeyDown(r);

    if (this.props.onEnd) {
      r.preventDefault();
      this.props.onEnd(r);
    }
  }

  onArrowKeyDown(r) {
    r.preventDefault();
    this.focusNextItem(r.keyCode);
  }

  onTabKeyDown(r) {
    r.target === this.firstHiddenTabStop && this.onFirstHiddenTabStopKeyDown(r);
  }

  onKeyUpHome() {
    this.isHomeKeyPressed = false;
  }

  onKeyUpEnd() {
    this.isEndKeyPressed = false;
  }

  onItemFocusEnter(r) {
    const t = r.id,
          a = r.relatedEvent,
          n = r.currentTarget,
          s = r.target;
    const l = !this.haveActiveItem() && !a && s === n;

    if (l) {
      this.setActiveItem(t);
      return;
    }

    const i = !this.haveActiveItem() && !a && n.contains(s);

    if (i) {
      this.setState(function () {
        return {
          activeItem: null,
          initialActiveItem: t,
          hasKeyboardFocus: true
        };
      });
      return;
    }

    const o = a && 'keydown' === a.type;
    o && this.setState(function () {
      return {
        activeItem: null,
        initialActiveItem: t,
        hasKeyboardFocus: true
      };
    });
  }

  onFocusEnter(r) {
    const t = r.relatedEvent,
          a = r.target;
    if (t && 'mousedown' === t.type) return;
    const n = a === this.firstHiddenTabStop;
    const s = a === this.lastHiddenTabStop;
    const l = !t;
    const i = !l && (n || s);
    const o = t && 'keydown' === t.type;
    const u = o || l;

    if (!u) {
      this.props.onFocusEnter && this.props.onFocusEnter(r);
      return;
    }

    i && this.moveFocusIntoVisibleScrollRegion({
      isFirstHiddenTabStop: n,
      shiftKeyPressed: t && t.shiftKey
    });
    this.props.onFocusEnter && this.props.onFocusEnter(Object.assign({
      isKeyboardFocus: true
    }, r));
  }

  onFocusLeave(r) {
    const t = this;
    const a = this.state.activeItem;
    const n = this.haveActiveItem() ? {
      activeItem: null,
      hasKeyboardFocus: false,
      initialActiveItem: a
    } : {
      activeItem: null,
      hasKeyboardFocus: false
    };
    const s = Object.assign({
      activeItem: a
    }, r);
    this.setState(function () {
      return n;
    }, function () {
      t.props.onFocusLeave && t.props.onFocusLeave(s);
    });
  }

  onItemMouseOver(r) {
    const t = r.id;
    this.setState(function () {
      return {
        hoveredItem: t
      };
    });
  }

  onItemMouseLeave() {
    this.setState(function () {
      return {
        hoveredItem: null,
        mouseDownTargetItem: null
      };
    });
  }

  onItemMouseDown(r) {
    const t = r.id;
    this.setState(function () {
      return {
        mouseDownTargetItem: t
      };
    });
  }

  onItemMouseUp() {
    this.setState(function () {
      return {
        mouseDownTargetItem: null
      };
    });
  }

  onFirstHiddenTabStopKeyDown(r) {
    const t = r.shiftKey;
    if (!t) return;
    r.preventDefault();
    this.updateTabIndexes();
    this.moveFocusIntoVisibleScrollRegion({
      isFirstHiddenTabStop: false,
      shiftKeyPressed: t
    });
  }

  moveFocusOnScrollEnd() {
    const r = this.getInitialActiveItem();

    if (r) {
      this.setActiveItem(r);
      this.isItemInView(r) || this.scrollToKey(r);
    }
  }

  focus() {
    const r = this;
    const t = this.getInitialActiveItem();
    if (!t) return;

    const a = function e() {
      r.focusTimerId = setTimeout(function () {
        r.lastHiddenTabStop.focus();
        r.firstHiddenTabStop.removeEventListener('focus', e, false);
      }, 250);
    };

    const n = function e() {
      r.focusTimerId = setTimeout(function () {
        r.setActiveItem(t);
        r.lastHiddenTabStop.removeEventListener('focus', e, false);
      }, 250);
    };

    if (this.focusTimerId) {
      clearTimeout(this.focusTimerId);
      this.firstHiddenTabStop.removeEventListener('focus', a, false);
      this.lastHiddenTabStop.removeEventListener('focus', n, false);
    } // TODO: check this


    if (
    /*Object( R[ 'isWindows' ] )() && this.props.useAriaApplicationMode*/
    false) {
      this.firstHiddenTabStop.addEventListener('focus', a, false);
      this.lastHiddenTabStop.addEventListener('focus', n, false);
      this.firstHiddenTabStop.focus();
    } else {
      this.setActiveItem(t);
      this.isItemInView(t) || this.scrollToKey(t);
    }
  }

  blur() {
    const r = document.activeElement; // @ts-ignore

    r && this.node.scroller.contains(r) && r.blur();
  }

  getActiveItem() {
    return this.state.activeItem;
  }

  setFirstHiddenTabStopRef(r) {
    this.firstHiddenTabStop = r;
  }

  setLastHiddenTabStopRef(r) {
    this.lastHiddenTabStop = r;
  }

  moveFocusIntoVisibleScrollRegion(r) {// var t = r.isFirstHiddenTabStop,
    // 	a = r.shiftKeyPressed;
    // if (!this.node) return;
    // var n = this.node.scroller;
    // var s = function () {
    // 	if (t && !a) return Object(w["b"])(n);
    // 	if (!t && a) return Object(w["c"])(n);
    // 	return null
    // }();
    // if (!s) return;
    // s.focus();
    // s.classList.add("focus-ring");
    // this.firstHiddenTabStop.removeAttribute("tabIndex");
    // this.lastHiddenTabStop.removeAttribute("tabIndex")
  }

  updateTabIndexes() {// if (!this.state.hasKeyboardFocus || !this.node) return;
    // var r = this.node.scroller;
    // var t = r.getBoundingClientRect();
    // var a = function e(r) {
    // 	var a = r.getBoundingClientRect();
    // 	var n = a.top >= t.top && a.bottom <= t.bottom;
    // 	return !n
    // };
    // var n = function e(t) {
    // 	return r.contains(t) && t.removeAttribute("tabIndex")
    // };
    // this.childrenScrolledOutOfView && this.childrenScrolledOutOfView.forEach(n);
    // var s = Object(w["a"])(r, a);
    // s.forEach(function (e) {
    // 	return e.setAttribute("tabIndex", -1)
    // });
    // this.childrenScrolledOutOfView = s
  }

  setActiveItem(r) {
    this.setState(function () {
      return {
        hasKeyboardFocus: true,
        hoveredItem: null,
        activeItem: r,
        initialActiveItem: r,
        setFocusOnScrollEnd: false
      };
    });
  }

  haveActiveItem() {
    return null !== this.state.activeItem;
  }

  focusFirstItem() {
    var r = this.getFocusableItemsInView()[0];
    this.state.activeItem !== r && this.setActiveItem(r);
  }

  focusLastItem() {
    var r = this.getFocusableItemsInView();
    var t = r[r.length - 1];
    this.state.activeItem !== t && this.setActiveItem(t);
  }

  focusNextItem(r) {// var t = this.getNextActiveItem( r, this.state.activeItem );
    // if ( t ) {
    //   this.setActiveItem( t );
    //   this.isItemInView( t ) || this.scrollToKey( t );
    // }
  }

  getFocusableItemsInView() {
    var r = this.props,
        t = r.keys,
        a = r.isFocusableItem;
    var n = this.getVisibleRange(),
        s = n.start,
        l = n.end; // TODO: check this

    return t.slice(s, l).filter(function (e) {
      return a({
        index: 0,
        //Object( g[ 'indexOf' ] )( t, e ),
        key: e
      });
    });
  }

  getFirstFocusableItemInView() {// var r = this.state.activeItem;
    // var t = this.getFocusableItemsInView()[ 0 ];
    // if ( ( t && t === r ) || ( ! t && r ) ) return this.getNextActiveItem( y[ 'l' ], r );
    // return t;
  }

  getLastFocusableItemInView() {// var r = this.state.activeItem;
    // var t = this.getFocusableItemsInView();
    // var a = t[ t.length - 1 ];
    // if ( ( a && a === r ) || ( ! a && r ) ) return this.getNextActiveItem( y[ 'a' ], r );
    // return a;
  }

  getInitialActiveItem() {
    // var r = this.state.initialActiveItem;
    // if (r === T) return this.getFirstFocusableItemInView();
    // if (r === I) return this.getLastFocusableItemInView();
    // if (!this.isItemInView(r)) return this.getFirstFocusableItemInView();
    // return r
    return null;
  }

  getNextActiveItem(r, t) {// if ( ! this.haveActiveItem() ) return this.getInitialActiveItem();
    // var a = t;
    // var n = Object( g[ 'indexOf' ] )( this.props.keys, a );
    // var s = r === y[ 'l' ] ? n - 1 : n + 1;
    // var l = this.props.keys[ s ];
    // if (
    //   l &&
    //   ! this.props.isFocusableItem( {
    //     index: s,
    //     key: l,
    //   } )
    // )
    //   return this.getNextActiveItem( r, l );
    // return l;
  }

  renderItem(t, r) {
    const a = this.getTop(t);
    const n = this.layout.getHeight(t);
    const i = this.layout.getHeightValidity(t);
    const s = this.state.activeItem === t;
    const o = null === this.state.activeItem && this.state.hasKeyboardFocus && this.state.initialActiveItem === t;
    const l = this.state.mouseDownTargetItem === t;
    const c = this.state.hoveredItem === t;
    const u = this.props.getAriaLabelForRow; // const p = this.props.isItemAriaExpanded;

    const d = u && u(r, {
      hasFocus: s
    }); // const h = p && p( t, a );

    return /*#__PURE__*/_react.createElement(ListItem, {
      key: t,
      id: t,
      height: n,
      validity: i,
      style: {
        top: a
      },
      role: this.props.itemRole,
      hasFocus: s,
      hasFocusWithin: o,
      isMouseDownOnItem: l,
      onHeightChange: this.setHeight,
      onFocusEnter: this.onItemFocusEnter,
      onFocusWithin: this.onItemFocusWithin,
      onMouseOver: this.onItemMouseOver,
      onMouseLeave: this.onItemMouseLeave,
      onMouseDown: this.onItemMouseDown,
      onMouseUp: this.onItemMouseUp,
      ariaLabel: d
    }, this.props.rowRenderer(r, {
      hasFocus: s,
      isHovered: c
    }));
  } // renderItem = ( r: any, t: any ) => {
  //   console.log('xxxxxxxxxxxxxxxxxxx', r);
  //   const a = this.getTop( r );
  //   var n = this.layout.getHeight( r );
  //   var s = this.state.activeItem === r;
  //   var l =
  //     null === this.state.activeItem &&
  //     this.state.hasKeyboardFocus &&
  //     this.state.initialActiveItem === r;
  //   var i = this.state.mouseDownTargetItem === r;
  //   var o = this.state.hoveredItem === r;
  //
  //   var u = this.props.getAriaLabelForRow;
  //   var c =
  //     u &&
  //     u( t, {
  //       hasFocus: s,
  //     } );
  //
  //   return (
  //     <ListItem
  //       id={ r }
  //       key={ r }
  //       height={ n }
  //       style={ { top: a } }
  //       role={ this.props.itemRole }
  //       onHeightChange={ this.setHeight }
  //       hasFocus={ s }
  //       hasFocusWithin={ l }
  //       isMouseDownOnItem={ i }
  //       onFocusEnter={ this.onItemFocusEnter }
  //       onFocusWithin={ this.onItemFocusWithin }
  //       onMouseOver={ this.onItemMouseOver }
  //       onMouseLeave={ this.onItemMouseLeave }
  //       onMouseDown={ this.onItemMouseDown }
  //       onMouseUp={ this.onItemMouseUp}
  //       ariaLabel={ c }
  //       shouldHorizontallyScroll={ this.props.shouldHorizontallyScroll }
  //     >
  //       { this.props.rowRenderer( r, {
  //         hasFocus: s,
  //         isHovered: o,
  //       } ) }
  //     </ListItem>
  //   );
  // };


  renderHiddenTabStop(r) {
    var t = r.key,
        a = r.tabIndex,
        n = r.ref;
    if (this.props.hideHiddenStopTabs) return null;
    var s = {
      position: 'absolute',
      width: '1px',
      height: '1px',
      outline: 'none',
      boxShadow: 'none'
    };
    return /*#__PURE__*/_react.createElement("div", {
      key: t,
      ref: n,
      tabIndex: a,
      style: s || {}
    });
  }

  onMouseInterceptorMouseMove(r) {
    var t = this;
    var a = r.screenX,
        n = r.screenY;

    if (!this.lastMouseCoords) {
      this.lastMouseCoords = {
        screenX: a,
        screenY: n
      };
      return;
    }

    var s = this.lastMouseCoords,
        l = s.screenX,
        i = s.screenY;
    this.lastMouseCoords = {
      screenX: a,
      screenY: n
    };
    var o = Math.abs(l - a);
    var u = Math.abs(i - n);
    if (0 === o && 0 === u) return;
    this.setState(function () {
      return {
        activeItem: null,
        initialActiveItem: t.state.activeItem,
        hasKeyboardFocus: false
      };
    }, function () {
      t.lastMouseCoords = null;
    });
  }

  renderMouseInterceptor() {
    var r = this.props,
        t = r.height,
        a = r.width;
    var n = {
      position: 'absolute',
      top: '0',
      left: '0',
      height: t,
      width: a,
      zIndex: 201
    };

    if (this.state.hasKeyboardFocus) {
      return /*#__PURE__*/_react.createElement("div", {
        style: n,
        onMouseMove: this.onMouseInterceptorMouseMove,
        "data-qa": "kb_list_mouse_interceptor"
      });
    }

    return null;
  } // TODO: check this
  // @ts-ignore


  render() {
    const t = this.state.hasKeyboardFocus ? '-1' : '0';
    const a = this.renderHiddenTabStop({
      key: 'first-hidden-tab-stop',
      tabIndex: t,
      ref: this.setFirstHiddenTabStopRef
    });
    const n = this.renderHiddenTabStop({
      key: 'last-hidden-tab-stop',
      tabIndex: t,
      ref: this.setLastHiddenTabStopRef
    });
    const s = 'presentation';
    const l = this.state.hasKeyboardFocus ? {
      position: 'relative'
    } : undefined;
    return /*#__PURE__*/_react.createElement(FocusManager, {
      onFocusEnter: this.onFocusEnter,
      onFocusLeave: this.onFocusLeave
    }, /*#__PURE__*/_react.createElement("div", {
      role: s,
      style: l
    }, n, super.render(), a, this.renderMouseInterceptor()));
  }

}

exports.KeyboardNavigableList = KeyboardNavigableList;
KeyboardNavigableList.defaultProps = Object.assign({}, List.defaultProps, {
  itemToFocus: undefined,
  initialActiveItem: undefined,
  isFocusableItems: noop,
  onFocusEnter: noop,
  onFocusLeave: noop,
  onPageUp: undefined,
  onPageDown: undefined,
  onHome: undefined,
  onEnd: undefined,
  keyCommands: undefined,
  useAriaApplicationMode: false,
  hideHiddenStopTabs: false,
  shouldIgnoreScrollKeys: function e() {
    return false; // ! this.state.hasKeyboardFocus;
  },
  shouldIgnoreArrowKeys: function e() {
    return false; // ! this.state.hasKeyboardFocus;
  }
});
const $eb7b678203c7931c69eeb67610aef$var$w = 400;

// TODO: check this
////// @ts-ignore
class DynamicList extends KeyboardNavigableList {
  // static defaultProps = Object.assign( {}, List.defaultProps, {
  //   className: '',
  //   layout: void 0,
  //   loadPre: noop,
  //   loadPost: noop,
  //   loadAround: noop,
  //   itemToScroll: void 0,
  //   animateOnScroll: false,
  // } );
  constructor(e) {
    super(e);
    this.pendingScrollTop = void 0;
    this.onScroll = this.onScroll.bind(this);
    this.setHeight = this.setHeight.bind(this);
    this.layout = e ? e.layout : new Layout();
    this.node = null;
    this.scrollTop = this.layout.setContainerHeight(e ? e.height : 0, 0);
    this.scrollTop = this.layout.setKeys(e ? e.keys : {}, this.scrollTop);

    if (this.props.useWindowScroller) {
      this.scrollTop = this.props.scrollTop || 0;
    }

    const r = this.layout.getBounds(this.scrollTop, this.scrollTop + e.height),
          i = r.start,
          s = r.end;
    const o = this.layout.getTops();
    this.state = Object.assign({}, this.state, {
      start: i,
      end: s,
      tops: o
    });
  }

  UNSAFE_componentWillReceiveProps(t) {
    // this.scrollToIfNotVisible( t );
    t.width !== this.props.width && this.layout.heightCache.invalidate();
    t.height !== this.props.height && (this.scrollTop = this.layout.setContainerHeight(t.height, this.getScrollTop()));

    if (!isEqual(t.keys, this.props.keys)) {
      if (!this.props.preventAutoScroll) {
        isEqual(t.keys, this.props.keys) || (this.scrollTop = this.layout.setKeys(t.keys, this.getScrollTop()));
      } else {
        this.layout.setKeys(t.keys, this.getScrollTop());
      }
    }

    this.relayout();
  }

  scrollToIfNotVisible(t) {
    const r = t.itemToScroll,
          a = t.animateOnScroll;
    r && this.scrollToKey(r, {
      lazy: true,
      animate: a
    });
  }

  componentDidUpdate() {
    // let a;
    // ( a = super.componentDidUpdate ).call.apply( a, [ this ].concat( arguments ) );
    'number' === typeof this.pendingScrollTop && this.setScrollTop(this.pendingScrollTop);
    this.loadMore();
  }

  componentDidMount() {
    super.componentDidMount();
    'number' === typeof this.pendingScrollTop && this.setScrollTop(this.pendingScrollTop);
    this.loadMore();
  }

  onScroll(r) {
    this.pendingScrollTop = false;
    super.onScroll(r);
  }

  getScrollTop() {
    if ('number' === typeof this.scrollTop) return this.scrollTop;
    if ('number' === typeof this.pendingScrollTop) return this.pendingScrollTop;
    if (!this.node) return 0;
    return super.getScrollTop();
  }

  setHeight(t, a) {
    if (!t) return;
    if (Math.abs(a - this.layout.getHeight(t)) < 0.5) return;
    const r = this.getScrollTop();
    this.scrollTop = this.layout.setHeight(t, a, r);
    this.relayout();
  }

  loadMore() {
    //if ( this.isScrolling() ) return false;
    const t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : this.state.start;
    const a = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : this.state.end;
    const r = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : this.props;
    const n = r.keys,
          i = r.height;
    const s = this.layout.getTotalHeight();
    const o = this.layout.getTop(n[t]);
    const l = this.layout.getBottom(n[a - 1]);
    const c = !n.length || s <= i || o < $eb7b678203c7931c69eeb67610aef$var$w;
    const u = !n.length || s <= i || s - l < $eb7b678203c7931c69eeb67610aef$var$w; // if ( c && u ) return r.loadAround();

    if (c && typeof r.loadPre === 'function') return r.loadPre();
    if (u && typeof r.loadPost === 'function') return r.loadPost();
    return null;
  } // renderItem( t: string, r: any ) {
  //   const a = this.getTop( t );
  //   const n = this.layout.getHeight( t );
  //   const i = this.layout.getHeightValidity( t );
  //   const s = this.state.activeItem === t;
  //   const o =
  //     null === this.state.activeItem &&
  //     this.state.hasKeyboardFocus &&
  //     this.state.initialActiveItem === t;
  //   const l = this.state.mouseDownTargetItem === t;
  //   const c = this.state.hoveredItem === t;
  //   const u = this.props.getAriaLabelForRow;
  //   // const p = this.props.isItemAriaExpanded;
  //   const d =
  //     u &&
  //     u( r, {
  //       hasFocus: s,
  //     } );
  //   // const h = p && p( t, a );
  //   return React.createElement(
  //     ListItem,
  //     {
  //       key: t,
  //       id: t,
  //       height: n,
  //       validity: i,
  //       style: {
  //         top: a,
  //       },
  //       role: this.props.itemRole,
  //       hasFocus: s,
  //       hasFocusWithin: o,
  //       isMouseDownOnItem: l,
  //       onHeightChange: this.setHeight,
  //       onFocusEnter: this.onItemFocusEnter,
  //       onFocusWithin: this.onItemFocusWithin,
  //       onMouseOver: this.onItemMouseOver,
  //       onMouseLeave: this.onItemMouseLeave,
  //       onMouseDown: this.onItemMouseDown,
  //       onMouseUp: this.onItemMouseUp,
  //       ariaLabel: d,
  //     },
  //     this.props.rowRenderer( r, {
  //       hasFocus: s,
  //       isHovered: c,
  //     } )
  //   );
  // }


  renderLoading(t) {
    const a = t ? {
      top: 0,
      paddingBottom: 8,
      paddingTop: 8,
      position: 'absolute'
    } : {
      bottom: 0,
      paddingBottom: 8,
      paddingTop: 8,
      position: 'absolute'
    };
    const r = t ? 'degradedLoadingTop' : 'degradedLoadingBottom';
    return /*#__PURE__*/_react.createElement('div', {
      key: r,
      className: _classnames(_ladifireCssSassIndexScss.display__flex, _ladifireCssSassIndexScss.width__100_percent, _ladifireCssSassIndexScss.align_item__center, _ladifireCssSassIndexScss.justify_content__center, _ladifireCssSassIndexScss.background_color__transparent),
      style: a
    }, /*#__PURE__*/_react.createElement('div', {
      className: 'p-degraded_list__loading_txt'
    }, 'Đang tải thêm...'));
  } // @ts-ignore


  renderItems(shouldRenderLoading) {
    if (shouldRenderLoading === void 0) {
      shouldRenderLoading = true;
    }

    const a = super.renderItems();
    const r = this.props.keys.length > 1 && (!this.props.reachedStart || this.state.start > 0);
    const i = this.props.keys.length > 1 && (!this.props.reachedEnd || this.state.end < this.props.keys.length); // TODO: check this
    // @ts-ignore

    return [r && shouldRenderLoading && this.renderLoading(true)].concat(
    /*n()(a)*/
    a, [i && shouldRenderLoading && this.renderLoading(false)]);
  }

  render() {
    this.pendingScrollTop = this.scrollTop;
    this.scrollTop = false;
    return super.render();
  }

}

exports.DynamicList = DynamicList;
DynamicList.displayName = 'DynamicList';

// @ts-ignore
const $cc56dc9c84b342bcb21facf0826dc83b$var$v = function e(t, a) {
  return t + '-' + a;
}; // @ts-ignore


const $cc56dc9c84b342bcb21facf0826dc83b$var$g = {
  add: (t, a, r) => {
    // @ts-ignore
    this.sections || (this.sections = {});
    const n = $cc56dc9c84b342bcb21facf0826dc83b$var$v(t, a); // @ts-ignore

    if (this.sections[n]) throw new Error('A section has already been specified at "' + n + '"'); // @ts-ignore

    this.sections[n] = r;
  },
  remove: (t, a) => {
    // @ts-ignore
    if (!this.sections) return;
    const r = $cc56dc9c84b342bcb21facf0826dc83b$var$v(t, a); // @ts-ignore

    if (!this.sections[r]) return; // @ts-ignore

    this.sections[r] = null; // @ts-ignore

    delete this.sections[r];
  },
  get: (t, a) => {
    // @ts-ignore
    if (!this.sections) return; // @ts-ignore

    return this.sections[$cc56dc9c84b342bcb21facf0826dc83b$var$v(t, a)];
  }
};

class FocusableSection extends _react.PureComponent {
  componentDidMount() {
    const t = this.props,
          a = t.teamId,
          r = t.order,
          n = t.component;
    $cc56dc9c84b342bcb21facf0826dc83b$var$g.add(a, r, n);
  }

  componentWillUnmount() {
    const t = this.props,
          a = t.teamId,
          r = t.order;
    $cc56dc9c84b342bcb21facf0826dc83b$var$g.remove(a, r);
  }

  render() {
    return this.props.children;
  }

}

exports.FocusableSection = FocusableSection;
FocusableSection.defaultProps = {
  children: undefined
};
// ASSET: /mnt/01D4AF1F1FC8FE60/Github/chot.sale/ladifire-ui-react/packages/@ladifire-ui-react/dynamic-list/src/mousetrap.ts
var $d62c4d908e13db39f65ffffc3d7095$var$_temp;

/**
 * Copyright 2012-2017 Craig Campbell
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Mousetrap is a simple keyboard shortcut library for Javascript with
 * no external dependencies
 *
 * @version 1.6.1
 * @url craig.is/killing/mice
 *
 * Changed by: JonWallsten - Converted to ES2015 and TypeScript.
 * @version 1.0.0
 */

/**
 * This is useful if you want to have a single entry to combos instead of letting devs create their own combos.
 */
let $d62c4d908e13db39f65ffffc3d7095$export$KeyBindings;

(function (KeyBindings) {
  KeyBindings["moveUp"] = "up";
  KeyBindings["moveDown"] = "down";
  KeyBindings["moveRight"] = "right";
  KeyBindings["moveLeft"] = "left";
  KeyBindings["pageUp"] = "pageup";
  KeyBindings["pageDown"] = "pagedown";
  KeyBindings["home"] = "home";
  KeyBindings["end"] = "end";
  KeyBindings["ctrlHome"] = "ctrl+home";
  KeyBindings["ctrlEnd"] = "ctrl+end";
})($d62c4d908e13db39f65ffffc3d7095$export$KeyBindings || ($d62c4d908e13db39f65ffffc3d7095$var$_temp = $d62c4d908e13db39f65ffffc3d7095$export$KeyBindings = {}, $d62c4d908e13db39f65ffffc3d7095$export$KeyBindings, $d62c4d908e13db39f65ffffc3d7095$var$_temp));

class _default {
  /**
   * mapping of special keycodes to their corresponding keys
   *
   * everything in this dictionary cannot use keypress events
   * so it has to be here to map to the correct keycodes for
   * keyup/keydown events
   */

  /**
   * mapping for special characters so they can support
   *
   * this dictionary is only used incase you want to bind a
   * keyup or keydown event to one of these keys
   */

  /**
   * this is a mapping of keys that require shift on a US keypad
   * back to the non shift equivelents
   *
   * this is so you can use keyup events with these keys
   *
   * note that this will only work reliably on US keyboards
   */

  /**
   * this is a list of special strings you can use to map
   * to modifier keys when you specify your keyboard shortcuts
   *
   * @type {Object}
   */

  /**
   * variable to store the flipped version of _MAP from above
   * needed to check if we should use keypress or not when no action
   * is specified
   */
  static _mapSpecialKeys() {
    /**
     * loop through the f keys, f1 to f19 and add them to the map
     * programatically
     */
    for (let i = 1; i < 20; ++i) {
      _default._MAP[111 + i] = 'f' + i;
    }
    /**
     * loop through to map numbers on the numeric keypad
     */


    for (let i = 0; i <= 9; ++i) {
      // This needs to use a string cause otherwise since 0 is falsey
      // mousetrap will never fire for numpad 0 pressed as part of a keydown
      // event.
      //
      // @see https://github.com/ccampbell/mousetrap/pull/258
      _default._MAP[i + 96] = i.toString();
    }
  }
  /**
   * cross browser add event method
   */


  static _addEvent(object, type, callback, useCapture) {
    if (object.addEventListener) {
      object.addEventListener(type, callback, useCapture || false);
      return;
    } // IE-specific attachEvent is no longer available


    object.attachEvent('on' + type, callback);
  }
  /**
   * cross browser remove event method
   *
   * @param {Element|HTMLDocument} object
   * @param {string} type
   * @param {Function} callback
   * @returns void
   */


  static _removeEvent(object, type, callback) {
    if (object.removeEventListener) {
      object.removeEventListener(type, callback, false);
      return;
    }

    object.detachEvent('on' + type, callback);
  }
  /**
   * takes the event and returns the key character
   */


  static _characterFromEvent(e) {
    // for keypress events we should return the character as is
    if (e.type === 'keypress') {
      let character = String.fromCharCode(e.which); // if the shift key is not pressed then it is safe to assume
      // that we want the character to be lowercase.  this means if
      // you accidentally have caps lock on then your key bindings
      // will continue to work
      // the only side effect that might not be desired is if you
      // bind something like 'A' cause you want to trigger an
      // event when capital A is pressed caps lock will no longer
      // trigger the event.  shift+a will though.

      if (!e.shiftKey) {
        character = character.toLowerCase();
      }

      return character;
    } // for non keypress events the special maps are needed


    if (_default._MAP[e.which]) {
      return _default._MAP[e.which];
    }

    if (_default._KEYCODE_MAP[e.which]) {
      return _default._KEYCODE_MAP[e.which];
    } // if it is not in the special map
    // with keydown and keyup events the character seems to always
    // come in as an uppercase character whether you are pressing shift
    // or not.  we should make sure it is always lowercase for comparisons


    return String.fromCharCode(e.which).toLowerCase();
  }
  /**
   * checks if two arrays are equal
   */


  static _modifiersMatch(modifiers1, modifiers2) {
    return modifiers1.sort().join(',') === modifiers2.sort().join(',');
  }
  /**
   * takes a key event and figures out what the modifiers are
   */


  static _eventModifiers(e) {
    const modifiers = [];

    if (e.shiftKey) {
      modifiers.push('shift');
    }

    if (e.altKey) {
      modifiers.push('alt');
    }

    if (e.ctrlKey) {
      modifiers.push('ctrl');
    }

    if (e.metaKey) {
      modifiers.push('meta');
    }

    return modifiers;
  }
  /**
   * prevents default for this event
   */


  static _preventDefault(e) {
    if (e.preventDefault) {
      e.preventDefault();
      return;
    }

    e.returnValue = false;
  }
  /**
   * stops propogation for this event
   */


  static _stopPropagation(e) {
    if (e.stopPropagation) {
      e.stopPropagation();
      return;
    }

    e.cancelBubble = true;
  }
  /**
   * determines if the keycode specified is a modifier key or not
   */


  static _isModifier(key) {
    return key === 'shift' || key === 'ctrl' || key === 'alt' || key === 'meta';
  }
  /**
   * reverses the map lookup so that we can look for specific keys
   * to see what can and can't use keypress
   */


  static _getReverseMap() {
    if (!_default._REVERSE_MAP) {
      _default._REVERSE_MAP = {};

      for (const key in _default._MAP) {
        // pull out the numeric keypad from here cause keypress should
        // be able to detect the keys from the character
        if (key > 95 && key < 112) {
          continue;
        }

        if (_default._MAP.hasOwnProperty(key)) {
          _default._REVERSE_MAP[_default._MAP[key]] = key;
        }
      }
    }

    return _default._REVERSE_MAP;
  }
  /**
   * picks the best action based on the key combination
   */


  static _pickBestAction(key, modifiers, action) {
    // if no action was picked in we should try to pick the one
    // that we think would work best for this key
    if (!action) {
      action = _default._getReverseMap()[key] ? 'keydown' : 'keypress';
    } // modifier keys don't work as expected with keypress,
    // switch to keydown


    if (action === 'keypress' && modifiers.length) {
      action = 'keydown';
    }

    return action;
  }
  /**
   * Converts from a string key combination to an array
   */


  static _keysFromString(combination) {
    if (combination === '+') {
      return ['+'];
    }

    combination = combination.replace(/\+{2}/g, '+plus');
    return combination.split('+');
  }
  /**
   * Gets info for a specific key combination
   * @returns {Object}
   */


  static _getKeyInfo(combination, action) {
    let keys;
    let key = '';
    let i;
    const modifiers = []; // take the keys from this pattern and figure out what the actual
    // pattern is all about

    keys = _default._keysFromString(combination);

    for (i = 0; i < keys.length; ++i) {
      key = keys[i]; // normalize key names

      if (_default._SPECIAL_ALIASES[key]) {
        key = _default._SPECIAL_ALIASES[key];
      } // if this is not a keypress event then we should
      // be smart about using shift keys
      // this will only work for US keyboards however


      if (action && action !== 'keypress' && _default._SHIFT_MAP[key]) {
        key = _default._SHIFT_MAP[key];
        modifiers.push('shift');
      } // if this key is a modifier then add it to the list of modifiers


      if (_default._isModifier(key)) {
        modifiers.push(key);
      }
    } // depending on what the key combination is
    // we will try to pick the best event for it


    action = _default._pickBestAction(key, modifiers, action || '');
    return {
      key,
      modifiers,
      action
    };
  }

  static _belongsTo(element, ancestor) {
    if (element === null || element === window.document) {
      return false;
    }

    if (element === ancestor) {
      return true;
    }

    return element.parentNode ? _default._belongsTo(element.parentNode, ancestor) : false;
  }
  /* ------------------------- NON STATIC ---------------------------- */

  /**
   * element to attach key events to
   */


  constructor(targetElement, useCapture) {
    this.target = void 0;
    this._callbacks = {};
    this._directMap = {};
    this._sequenceLevels = {};
    this._resetTimer = void 0;
    this._ignoreNextKeyup = false;
    this._ignoreNextKeypress = false;
    this._nextExpectedAction = false;
    this.destroy = void 0;

    this.addKeycodes = object => {
      for (const key in object) {
        if (object.hasOwnProperty(key)) {
          _default._MAP[key] = object[key];
        }
      }

      _default._REVERSE_MAP = null;
    };

    this.target = targetElement || window.document; // Some keys is mapped programatically

    _default._mapSpecialKeys();

    const scopepHandleKeyEvent = e => this._handleKeyEvent(e); // Bind events


    _default._addEvent(this.target, 'keypress', scopepHandleKeyEvent, useCapture);

    _default._addEvent(this.target, 'keydown', scopepHandleKeyEvent, useCapture);

    _default._addEvent(this.target, 'keyup', scopepHandleKeyEvent, useCapture); // Unbind events and reset callbacks


    this.destroy = () => {
      _default._removeEvent(this.target, 'keypress', scopepHandleKeyEvent);

      _default._removeEvent(this.target, 'keydown', scopepHandleKeyEvent);

      _default._removeEvent(this.target, 'keyup', scopepHandleKeyEvent);

      this.reset();
    };
  }
  /**
   * resets all sequence counters except for the ones passed in
   *
   * @param {Object} doNotReset
   * @returns void
   */


  _resetSequences(doNotReset) {
    if (doNotReset === void 0) {
      doNotReset = {};
    }

    let activeSequences = false;

    for (const key in this._sequenceLevels) {
      if (doNotReset[key]) {
        activeSequences = true;
        continue;
      }

      this._sequenceLevels[key] = 0;
    }

    if (!activeSequences) {
      this._nextExpectedAction = false;
    }
  }
  /**
   * finds all callbacks that match based on the keycode, modifiers,
   */


  _getMatches(character, modifiers, e, sequenceName, combination, level) {
    let i;
    let callback;
    const matches = [];
    const action = e && e.type; // if there are no events related to this keycode

    if (!this._callbacks[character]) {
      return [];
    } // if a modifier key is coming up on its own we should allow it


    if (action === 'keyup' && _default._isModifier(character)) {
      modifiers = [character];
    } // loop through all callbacks for the key that was pressed
    // and see if any of them match


    for (i = 0; i < this._callbacks[character].length; ++i) {
      callback = this._callbacks[character][i]; // if a sequence name is not specified, but this is a sequence at
      // the wrong level then move onto the next match

      if (!sequenceName && callback.seq && this._sequenceLevels[callback.seq] !== callback.level) {
        continue;
      } // if the action we are looking for doesn't match the action we got
      // then we should keep going


      if (action !== callback.action) {
        continue;
      } // if this is a keypress event and the meta key and control key
      // character, otherwise check the modifiers as well
      //
      // chrome will not fire a keypress if meta or control is down
      // safari will fire a keypress if meta or meta+shift is down
      // firefox will fire a keypress if meta or control is down


      if (action === 'keypress' && e && !e.metaKey && !e.ctrlKey || modifiers && _default._modifiersMatch(modifiers, callback.modifiers)) {
        // when you bind a combination or sequence a second time it
        // should overwrite the first one.  if a sequenceName or
        // combination is specified in this call it does just that
        //
        // @todo make deleting its own method?
        const deleteCombo = !sequenceName && callback.combo === combination;
        const deleteSequence = sequenceName && callback.seq === sequenceName && callback.level === level;

        if (deleteCombo || deleteSequence) {
          this._callbacks[character].splice(i, 1);
        }

        matches.push(callback);
      }
    }

    return matches;
  }
  /**
   * actually calls the callback function
   *
   * if your callback function returns false this will use the jquery
   * convention - prevent default and stop propogation on the event
   */


  _fireCallback(callback, e, combo) {
    // if this event should not happen stop here
    if (this.stopCallback(e, e.target || e.srcElement)) {
      return;
    } // Why assume callback return something?


    if (callback(e, combo) === false) {
      _default._preventDefault(e);

      _default._stopPropagation(e);
    }
  }
  /**
   * handles a character key event
   *
   * @param {string} character
   * @param {Array} modifiers
   * @param {Event} e
   * @returns void
   */


  _handleKey(character, modifiers, e) {
    const callbacks = this._getMatches(character, modifiers, e);

    let i;
    const doNotReset = {};
    let maxLevel = 0;
    let processedSequenceCallback = false; // Calculate the maxLevel for sequences so we can only execute the longest callback sequence

    for (i = 0; i < callbacks.length; ++i) {
      if (callbacks[i].seq) {
        maxLevel = Math.max(maxLevel, callbacks[i].level);
      }
    } // loop through matching callbacks for this key event


    for (i = 0; i < callbacks.length; ++i) {
      // fire for all sequence callbacks
      // this is because if for example you have multiple sequences
      // bound such as "g i" and "g t" they both need to fire the
      // callback for matching g cause otherwise you can only ever
      // match the first one
      if (callbacks[i].seq) {
        // only fire callbacks for the maxLevel to prevent
        // subsequences from also firing
        //
        // for example 'a option b' should not cause 'option b' to fire
        // even though 'option b' is part of the other sequence
        //
        // any sequences that do not match here will be discarded
        // below by the _resetSequences call
        if (callbacks[i].level !== maxLevel) {
          continue;
        }

        processedSequenceCallback = true; // keep a list of which sequences were matches for later

        doNotReset[callbacks[i].seq] = 1;
        e && this._fireCallback(callbacks[i].callback, e, callbacks[i].combo);
        continue;
      } // if there were no sequence matches but we are still here
      // that means this is a regular match so we should fire that


      if (!processedSequenceCallback) {
        e && this._fireCallback(callbacks[i].callback, e, callbacks[i].combo);
      }
    } // if the key you pressed matches the type of sequence without
    // being a modifier (ie "keyup" or "keypress") then we should
    // reset all sequences that were not matched by this event
    //
    // this is so, for example, if you have the sequence "h a t" and you
    // type "h e a r t" it does not match.  in this case the "e" will
    // cause the sequence to reset
    //
    // modifier keys are ignored because you can have a sequence
    // that contains modifiers such as "enter ctrl+space" and in most
    // cases the modifier key will be pressed before the next key
    //
    // also if you have a sequence such as "ctrl+b a" then pressing the
    // "b" key will trigger a "keypress" and a "keydown"
    //
    // the "keydown" is expected when there is a modifier, but the
    // "keypress" ends up matching the this._nextExpectedAction since it occurs
    // after and that causes the sequence to reset
    //
    // we ignore keypresses in a sequence that directly follow a keydown
    // for the same character


    const ignoreThisKeypress = e && e.type === 'keypress' && this._ignoreNextKeypress;

    if (e && e.type === this._nextExpectedAction && !_default._isModifier(character) && !ignoreThisKeypress) {
      this._resetSequences(doNotReset);
    }

    this._ignoreNextKeypress = e && processedSequenceCallback && e.type === 'keydown' || false;
  }
  /**
   * handles a keydown event
   */


  _handleKeyEvent(e) {
    // normalize e.which for key events
    // @see http://stackoverflow.com/questions/4285627/javascript-keycode-vs-charcode-utter-confusion
    if (typeof e.which !== 'number') {
      //e.which is read-only. Cast as any to ignore.
      e.which = e.keyCode;
    }

    const character = _default._characterFromEvent(e); // no character found then stop


    if (!character) {
      return;
    } // need to use === for the character check because the character can be 0


    if (e.type === 'keyup' && this._ignoreNextKeyup === character) {
      this._ignoreNextKeyup = false;
      return;
    }

    this._handleKey(character, _default._eventModifiers(e), e);
  }
  /**
   * called to set a 1 second timeout on the specified sequence
   *
   * this is so after each key press in the sequence you have 1 second
   * to press the next key before you have to start over
   */


  _resetSequenceTimer() {
    this._resetTimer && clearTimeout(this._resetTimer);
    this._resetTimer = window.setTimeout(this._resetSequences, 1000);
  }
  /**
   * binds a key sequence to an event
   */


  _bindSequence(combo, keys, callback, action) {
    // start off by adding a sequence level record for this combination
    // and setting the level to 0
    this._sequenceLevels[combo] = 0;
    /**
     * callback to increase the sequence level for this sequence and reset
     * all other sequences that were active
     */

    const _increaseSequence = nextAction => {
      return () => {
        this._nextExpectedAction = nextAction;
        ++this._sequenceLevels[combo];

        this._resetSequenceTimer();

        return false;
      };
    };
    /**
     * wraps the specified callback inside of another function in order
     * to reset all sequence counters as soon as this sequence is done
     */


    const _callbackAndReset = e => {
      this._fireCallback(callback, e, combo); // we should ignore the next key up if the action is key down
      // or keypress.  this is so if you finish a sequence and
      // release the key the final key will not trigger a keyup


      if (action !== 'keyup') {
        this._ignoreNextKeyup = _default._characterFromEvent(e);
      } // weird race condition if a sequence ends with the key
      // another sequence begins with


      window.setTimeout(this._resetSequences, 10);
      return false;
    }; // loop through keys one at a time and bind the appropriate callback
    // function.  for any key leading up to the final one it should
    // increase the sequence. after the final, it should reset all sequences
    //
    // if an action is specified in the original bind call then that will
    // be used throughout.  otherwise we will pass the action that the
    // next key in the sequence should match.  this allows a sequence
    // to mix and match keypress and keydown events depending on which
    // ones are better suited to the key provided


    for (let i = 0; i < keys.length; ++i) {
      const isFinal = i + 1 === keys.length;
      const wrappedCallback = isFinal ? _callbackAndReset : _increaseSequence(action || _default._getKeyInfo(keys[i + 1]).action);

      this._bindSingle(keys[i], wrappedCallback, action, combo, i);
    }
  }
  /**
   * binds a single keyboard combination
   */


  _bindSingle(combination, callback, action, sequenceName, level) {
    // store a direct mapped reference for use with Mousetrap.trigger
    this._directMap[combination + ':' + action] = callback; // make sure multiple spaces in a row become a single space

    combination = combination.replace(/\s+/g, ' ');
    const sequence = combination.split(' ');
    let info; // if this pattern is a sequence of keys then run through this method
    // to reprocess each pattern one key at a time

    if (sequence.length > 1) {
      this._bindSequence(combination, sequence, callback, action);

      return;
    }

    info = _default._getKeyInfo(combination, action); // make sure to initialize array if this is the first time
    // a callback is added for this key

    this._callbacks[info.key] = this._callbacks[info.key] || []; // remove an existing match if there is one

    this._getMatches(info.key, info.modifiers, {
      type: info.action
    }, sequenceName, combination, level); // add this call back to the array
    // if it is a sequence put it at the beginning
    // if not put it at the end
    //
    // this is important because the way these are processed expects
    // the sequence ones to come first


    this._callbacks[info.key][sequenceName ? 'unshift' : 'push']({
      callback,
      modifiers: info.modifiers,
      action: info.action,
      seq: sequenceName || '',
      level: level || 0,
      combo: combination
    });
  }
  /**
   * binds multiple combinations to the same callback
   */


  _bindMultiple(combinations, callback, action) {
    for (let i = 0; i < combinations.length; ++i) {
      this._bindSingle(combinations[i], callback, action || '');
    }
  }
  /**
   * binds an event to mousetrap
   *
   * can be a single key, a combination of keys separated with +,
   * an array of keys, or a sequence of keys separated by spaces
   *
   * be sure to list the modifier keys first to make sure that the
   * correct key ends up getting bound (the last key in the pattern)
   */


  bind(keys, callback, action) {
    keys = Array.isArray(keys) ? keys : [keys];

    this._bindMultiple(keys, callback, action);
  }
  /**
   * unbinds an event to mousetrap
   *
   * the unbinding sets the callback function of the specified key combo
   * to an empty function and deletes the corresponding key in the
   * _directMap dict.
   *
   * TODO: actually remove this from the _callbacks dictionary instead
   * of binding an empty function
   *
   * the keycombo+action has to be exactly the same as
   * it was defined in the bind method
   */


  unbind(keys, action) {
    const emptyFunc = () => {
      return false;
    };

    this.bind(keys, emptyFunc, action);
  }
  /**
   * triggers an event that has already been bound
   */


  trigger(keys, action) {
    if (this._directMap[keys + ':' + action]) {
      this._directMap[keys + ':' + action]({}, keys);
    }
  }
  /**
   * resets the library back to its initial state.  this is useful
   * if you want to clear out the current keyboard shortcuts and bind
   * new ones - for example if you switch to another page
   */


  reset() {
    this._callbacks = {};
    this._directMap = {};
  }
  /**
   * should we stop this event before firing off callbacks
   */


  stopCallback(e, element) {
    // if the element has the class "mousetrap" then no need to stop
    if ((' ' + element.className + ' ').indexOf(' mousetrap ') > -1) {
      return false;
    }

    if (_default._belongsTo(element, this.target)) {
      return false;
    } // stop for input, select, and textarea


    return element.tagName === 'INPUT' || element.tagName === 'SELECT' || element.tagName === 'TEXTAREA' || element.isContentEditable;
  }
  /**
   * exposes _handleKey publicly so it can be overwritten by extensions
   */


  handleKey() {
    return this._handleKey(arguments);
  }
  /**
   * allow custom key mappings
   */


}

exports.default = _default;
_default._MAP = {
  8: 'backspace',
  9: 'tab',
  13: 'enter',
  16: 'shift',
  17: 'ctrl',
  18: 'alt',
  20: 'capslock',
  27: 'esc',
  32: 'space',
  33: 'pageup',
  34: 'pagedown',
  35: 'end',
  36: 'home',
  37: 'left',
  38: 'up',
  39: 'right',
  40: 'down',
  45: 'ins',
  46: 'del',
  91: 'meta',
  93: 'meta',
  224: 'meta'
};
_default._KEYCODE_MAP = {
  106: '*',
  107: '+',
  109: '-',
  110: '.',
  111: '/',
  186: ';',
  187: '=',
  188: ',',
  189: '-',
  190: '.',
  191: '/',
  192: '`',
  219: '[',
  220: '\\',
  221: ']',
  222: '\''
};
_default._SHIFT_MAP = {
  '~': '`',
  '!': '1',
  '@': '2',
  '#': '3',
  '$': '4',
  '%': '5',
  '^': '6',
  '&': '7',
  '*': '8',
  '(': '9',
  ')': '0',
  '_': '-',
  '+': '=',
  ':': ';',
  '\"': '\'',
  '<': ',',
  '>': '.',
  '?': '/',
  '|': '\\'
};
_default._SPECIAL_ALIASES = {
  'option': 'alt',
  'command': 'meta',
  'return': 'enter',
  'escape': 'esc',
  'plus': '+',
  'mod': /Mac|iPod|iPhone|iPad/.test(navigator.platform) ? 'meta' : 'ctrl'
};
_default._REVERSE_MAP = void 0;

const $e3c51a38a3a2095e52207ebfeab3f80$var$_ = function e(r) {
  // TODO: check this
  // @ts-ignore
  return _default.stopCallback(r, r.target);
};

const $e3c51a38a3a2095e52207ebfeab3f80$var$h = function e(r, t) {
  return function () {
    const xx = arguments.length <= 0 ? void 0 : arguments[0];
    if (t(xx)) return;
    r.apply(void 0, arguments);
  };
};

const $e3c51a38a3a2095e52207ebfeab3f80$var$f = function e(r, t) {
  const n = t[0];
  return n ? e($e3c51a38a3a2095e52207ebfeab3f80$var$h(r, n), t.slice(1)) : r;
};

const $e3c51a38a3a2095e52207ebfeab3f80$var$m = function e(r) {
  const t = r.ignoreInputs && $e3c51a38a3a2095e52207ebfeab3f80$var$_;
  return [t, r.filter].filter(isFunction);
};

class KeyCommands {
  constructor() {
    this.mousetrap = void 0;
    this.mousetrap = new _default();
  }

  bindAll(r) {
    const t = this;
    r.forEach(function (e) {
      const rr = $e3c51a38a3a2095e52207ebfeab3f80$var$m(e);
      e.handler = $e3c51a38a3a2095e52207ebfeab3f80$var$f(e.handler, rr);
      t.mousetrap.bind(e.keys, e.handler, e.action);
    });
  }

  reset() {
    const t = this;
    t.mousetrap.reset();
  }

  unbindAll(t) {
    const r = this; // TODO: check this
    // @ts-ignore

    r.mousetrap.unbind(flatMap(t, 'keys'));
  }

  trigger(r, t) {
    const x = this;
    x.mousetrap.trigger(r, t);
  }

}

exports.KeyCommands = KeyCommands;
const $a90932dca79a696ebfcedcbd67ca8a$var$C = 20;

class MessageDynamicList extends DynamicList {
  constructor(props) {
    super(props);
    this.pendingUpdate = void 0;
    this.overscan = void 0;
    this.startTop = void 0;
    this.endBottom = void 0;
    this.scrollAnimation = void 0;
    this.startKey = void 0;
    this.endKey = void 0;

    this.renderEmptyState = () => {
      return /*#__PURE__*/_react.createElement("div", {
        className: _classnames(_ladifireCssSassIndexScss.display__flex, _ladifireCssSassIndexScss.align_item__center, _ladifireCssSassIndexScss.justify_content__center),
        style: {
          width: this.props.width,
          height: this.props.height
        }
      }, this.props.isLoading || this.props.isLoadingMore ? /*#__PURE__*/_react.createElement(ProgressCircle, {
        "aria-label": "loading",
        isIndeterminate: true,
        size: 24
      }) : /*#__PURE__*/_react.createElement("div", null));
    };

    this.renderRows = () => {
      const r = this;
      const t = this.props,
            n = t.keys,
            a = t.persistentKeys;
      const s = this.state,
            l = s.start,
            i = s.end;
      const o = [];

      for (let u = l; u < i; u++) {
        const c = n[u];
        c && o.push(this.renderItem(c, u));
      }

      a && a.forEach(function (e) {
        const tt = n.indexOf(e);
        if (tt < 0) return;
        if (tt >= l && tt < i) return;
        o.push(r.renderItem(e, tt));
      });
      return o;
    };

    this.pendingUpdate = null;
    this.recomputeOffsets(props);
    this.overscan = Math.max(200, props.height / 2);
  }

  componentDidUpdate() {
    console.log('xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx');
    super.componentDidUpdate();
    0 === this.props.keys.length && this.loadMore();
    this.layout.setBottomMargin(this.getLoadingOffsetBottom());
    this.pendingUpdate = false;
  }

  UNSAFE_componentWillReceiveProps(r) {
    super.UNSAFE_componentWillReceiveProps(r);

    if (r.itemToScroll !== this.props.itemToScroll) {
      this.scrollToKey(r.itemToScroll);
    }
  }

  getOffset() {
    const t = this.getLoadingOffsetTop();
    return this.startTop - t;
  }

  getLoadingOffsetTop() {
    // return 0;
    if (!this.props.keys.length) return 0;
    if (this.props.reachedStart && 0 === this.state.start) return 0;
    if (this.layout.getTotalHeight() <= this.props.height) return 0;
    if (0 !== this.state.start) return 40;
    return 40;
  }

  getLoadingOffsetBottom() {
    // return 0;
    if (!this.props.keys.length) return 0;
    if (this.props.reachedEnd && this.state.end === this.props.keys.length) return 0;
    return 40;
  }

  getScrollTop() {
    if (this.props.useWindowScroller) {
      return this.props.scrollTop;
    }

    if ('number' === typeof this.scrollTop) return this.scrollTop;
    if ('number' === typeof this.pendingScrollTop) return this.pendingScrollTop;
    return super.getScrollTop() + this.getOffset();
  }

  getContentHeight() {
    const a = this.layout.getTotalHeight();

    if (this.props.useWindowScroller) {
      return a - this.getOffset() + this.getLoadingOffsetBottom();
    }

    return this.endBottom - this.getOffset() + this.getLoadingOffsetBottom();
  }

  getTop(t) {
    return this.layout.getTop(t) - this.getOffset();
  }

  getBottom(t) {
    return this.layout.getBottom(t) - this.getOffset();
  }

  setScrollTop(a) {
    console.log('this.pendingUpdate: ', this.pendingUpdate);
    if (this.pendingUpdate) return;
    const r = a < this.getOffset();
    const n = a + this.props.height > this.endBottom + this.getLoadingOffsetBottom();

    if (r && 0 !== this.state.start || n && this.state.end !== this.props.keys.length) {
      this.scrollTop = a;
      this.relayout();
      return;
    }

    super.setScrollTop(a - this.getOffset());
  }

  scrollToOffset(a) {
    const r = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {},
          n = r.animate,
          i = r.absolute;
    if (!this.node) return;
    if (this.pendingUpdate) return;
    let s = i ? a : a - this.getOffset();
    !i && s > 0 && s < this.getLoadingOffsetTop() && (s = 0);
    const o = this.bracketScrollTop(s);

    if (!i && o !== s) {
      this.setScrollTop(a);
      return;
    }

    if (n) {
      this.scrollAnimation = this.node.scrollWithAnimation(o);
      return;
    }

    super.setScrollTop(o);
  }

  bracketScrollTop(t) {
    return Math.max(0, Math.min(this.getContentHeight() - this.props.height, t));
  }

  resetRendered() {
    this.overscan = this.props.height / 2;
  }

  loadMore(start, end, props) {
    if (start === void 0) {
      start = this.state.start;
    }

    if (end === void 0) {
      end = this.state.end;
    }

    if (props === void 0) {
      props = this.props;
    }

    if (this.props.isLoading || this.props.isLoadingMore) {
      return;
    }

    const t = start; //arguments.length > 0 && void 0 !== arguments[ 0 ] ? arguments[ 0 ] : this.state.start;

    const a = end; //arguments.length > 1 && void 0 !== arguments[ 1 ] ? arguments[ 1 ] : this.state.end;

    const r = props; //arguments.length > 2 && void 0 !== arguments[ 2 ] ? arguments[ 2 ] : this.props;

    const n = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : this.getScrollTop();
    const i = this.layout.getTotalHeight();
    const s = 0 === t && n < 1;
    const o = a === r.keys.length && n + r.height > i - 1;
    const l = !r.keys.length || i <= r.height || s;
    const c = !r.keys.length || i <= r.height || o; // console.log('===scrollTop: ', this.props.scrollTop);
    // console.log('===getTotalHeight: ', this.layout.getTotalHeight());
    // console.log('===containerHeight: ', this.props.height);

    const _mustRequestMore = this.props.useWindowScroller && this.props.scrollTop + this.props.height > i + 40;

    if (_mustRequestMore && typeof r.loadPost === 'function') {
      return r.loadPost();
    } // console.log('mustCallLoadPost: ', s, o);


    if (l && c && typeof r.loadAround === 'function') {
      return r.loadAround();
    }

    if (l && typeof r.loadPre === 'function') {
      return r.loadPre();
    }

    if (c
    /* || mustCallLoadPost*/
    && typeof r.loadPost === 'function') {
      return r.loadPost();
    }

    return false;
  }

  relayout() {
    const t = this;
    this.setState(function (e, a) {
      if (a.isLoading || a.isLoadingOlder) return null;
      const r = e.start,
            n = e.end;
      const i = t.startKey;
      const o = t.endKey;
      t.recomputeOffsets(a, r, n);
      const l = this.props.useWindowScroller ? this.props.scrollTop : t.node ? t.node.scrollTop() : 0;
      const c = t.getScrollTop();
      let u = l - 1 <= 0 || c - 1 <= t.getOffset();
      let d = l + 1 >= t.getContentHeight() - a.height || c + 1 >= t.endBottom - a.height;
      let p = {
        start: r,
        end: n
      };

      if (t.startKey !== i || t.endKey !== o || u && 0 !== r || d && n !== a.keys.length) {
        e.scrolling && (t.overscan = 8e3);
        p = t.computeBounds(a, c);
        const m = p,
              h = m.start,
              f = m.end;
        t.recomputeOffsets(a, h, f);
        u = c - 1 <= t.getOffset();
        d = c + a.height + 1 >= t.endBottom + t.getLoadingOffsetBottom();
      } // if ( ( u && 0 === p.start ) ||
      //     ( d && p.end === a.keys.length ) ||
      //     ( t.layout.getTotalHeight() < a.height && 0 === p.start ) ) {
      //   // console.log('must call load more...');
      //   t.loadMore( r, n, a );
      // }


      const v = t.layout.getTops();
      if (p.start === r && p.end === n && v === e.tops) return null;
      t.scrollAnimation && t.scrollAnimation.cancel();
      t.pendingUpdate = true; // console.log("c", c);

      c > 0 && (t.scrollTop = c);
      return Object.assign({}, p, {
        tops: v
      });
    }, () => {
      if (typeof this.props.onContentHeightChange === 'function') {
        this.props.onContentHeightChange(this.layout.getTotalHeight());
      }
    });
  }

  recomputeOffsets(props, xx, y) {
    const t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : this.props;
    const a = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : this.state.start;
    const r = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : this.state.end;
    const n = this.layout.getTotalHeight() <= t.height;
    this.startKey = t.keys[a];
    this.endKey = t.keys[r - 1];
    this.startTop = n ? 0 : this.layout.getTop(this.startKey) || 0;
    this.endBottom = this.layout.getBottom(this.endKey) || 0;
  }

  computeBounds(argument1, argument2) {
    const a = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : this.props;
    const r = arguments[1];
    const n = r - this.overscan;
    const i = r + a.height + this.overscan;
    const s = super.getBounds(n, i);
    return this.snapBounds(a, s);
  }

  snapBounds(argument1, argument2) {
    const t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : this.props;
    const a = arguments[1];
    const r = a.start,
          n = a.end;
    return {
      start: r < $a90932dca79a696ebfcedcbd67ca8a$var$C ? 0 : r,
      end: t.keys.length - n < $a90932dca79a696ebfcedcbd67ca8a$var$C ? t.keys.length : n
    };
  }

  renderLoading(t) {
    const a = t ? {
      top: 0,
      paddingBottom: 8,
      paddingTop: 8,
      position: 'absolute'
    } : {
      bottom: 0,
      paddingBottom: 8,
      paddingTop: 8,
      position: 'absolute'
    };
    const r = t ? 'degradedLoadingTop' : 'degradedLoadingBottom';
    return /*#__PURE__*/_react.createElement("div", {
      key: r,
      className: _classnames(_ladifireCssSassIndexScss.display__flex, _ladifireCssSassIndexScss.width__100_percent, _ladifireCssSassIndexScss.align_item__center, _ladifireCssSassIndexScss.justify_content__center, _ladifireCssSassIndexScss.background_color__transparent),
      style: a
    }, typeof this.props.itemLoadingRenderer === 'function' ? this.props.itemLoadingRenderer() : /*#__PURE__*/_react.createElement("div", {
      className: _classnames(_ladifireCssSassIndexScss.display__flex, _ladifireCssSassIndexScss.align_item__center, _ladifireCssSassIndexScss.justify_content__center)
    }, typeof this.props.itemLoadingRenderer === 'function' ? this.props.itemLoadingRenderer() : /*#__PURE__*/_react.createElement(ProgressCircle, {
      "aria-label": "loading",
      isIndeterminate: true,
      size: 24
    }))); // return React.createElement(
    //   'div',
    //   {
    //     key: r,
    //     className: classNames(
    //       gs.display__flex,
    //       gs.width__100_percent,
    //       gs.align_item__center,
    //       gs.justify_content__center,
    //       gs.background_color__transparent,
    //     ),
    //     style: a,
    //   },
    //   React.createElement(
    //     'div',
    //     {
    //       className: 'p-degraded_list__loading_txt',
    //     },
    //     'Đang tải thêm...'
    //   )
    // );
  }

  // TODO: not check this in V2
  renderItem(t, r) {
    if (!this.props.useWindowScroller) {
      return super.renderItem(t, r);
    }

    const a = this.layout.getTop(t);
    const n = this.layout.getHeight(t);
    const i = this.layout.getHeightValidity(t);
    const s = this.state.activeItem === t;
    const o = null === this.state.activeItem && this.state.hasKeyboardFocus && this.state.initialActiveItem === t;
    const l = this.state.mouseDownTargetItem === t;
    const c = this.state.hoveredItem === t;
    const u = this.props.getAriaLabelForRow; // const p = this.props.isItemAriaExpanded;

    const d = u && u(r, {
      hasFocus: s
    }); // const h = p && p( t, a );

    return /*#__PURE__*/_react.createElement(ListItem, {
      key: t,
      id: t,
      height: n,
      validity: i,
      style: {
        top: a
      },
      role: this.props.itemRole,
      hasFocus: s,
      hasFocusWithin: o,
      isMouseDownOnItem: l,
      onHeightChange: this.setHeight,
      onFocusEnter: this.onItemFocusEnter,
      onFocusWithin: this.onItemFocusWithin,
      onMouseOver: this.onItemMouseOver,
      onMouseLeave: this.onItemMouseLeave,
      onMouseDown: this.onItemMouseDown,
      onMouseUp: this.onItemMouseUp,
      ariaLabel: d
    }, this.props.rowRenderer(r, {
      hasFocus: s,
      isHovered: c
    }));
  }

  // @ts-ignore
  renderItems() {
    if (!this.props.keys || this.props.keys.length === 0) {
      return this.renderEmptyState();
    }

    const a = this.props.useWindowScroller ? this.renderRows() : super.renderItems(false);
    const shouldRenderLoadingPre = this.props.keys.length > 1 && (!this.props.reachedStart || this.state.start > 0);
    const shouldRenderLoadingPost = this.props.keys.length > 1 && (!this.props.reachedEnd || this.state.end < this.props.keys.length); // TODO: check this
    // @ts-ignore

    return [shouldRenderLoadingPre && this.renderLoading(true)].concat(a, [shouldRenderLoadingPost && this.renderLoading(false)]);
  }

  renderContents() {
    if (!this.props.useWindowScroller) {
      return super.renderContents();
    }

    const r = this.getContentsClassName();
    let t = this.layout.getTotalHeight();
    const n = this.renderItems();
    const shouldRenderLoadingPre = this.props.keys.length > 1 && (!this.props.reachedStart || this.state.start > 0);
    const shouldRenderLoadingPost = this.props.keys.length > 1 && (!this.props.reachedEnd || this.state.end < this.props.keys.length);

    if (shouldRenderLoadingPost) {
      t = t + 40;
    }

    return /*#__PURE__*/_react.createElement("div", {
      ref: this.setContentRef,
      className: r,
      role: "presentation",
      style: {
        position: 'relative',
        height: t
      }
    }, n);
  }

}

exports.MessageDynamicList = MessageDynamicList;
MessageDynamicList.displayName = 'DynamicList';

function $ca6b875d36bb40f35f34ccb5eee9ec5d$export$default(nonce, hostWindow) {
  // Check `document` and `window` in case of server-side rendering
  var _window;

  if (typeof hostWindow !== 'undefined') {
    _window = hostWindow;
  } else if (typeof window !== 'undefined') {
    _window = window;
  } else if (typeof self !== 'undefined') {
    _window = self;
  } else {
    _window = $parcel$global;
  }

  var attachEvent = typeof _window.document !== 'undefined' && _window.document.attachEvent;

  if (!attachEvent) {
    var requestFrame = function () {
      var raf = _window.requestAnimationFrame || _window.mozRequestAnimationFrame || _window.webkitRequestAnimationFrame || function (fn) {
        return _window.setTimeout(fn, 20);
      };

      return function (fn) {
        return raf(fn);
      };
    }();

    var cancelFrame = function () {
      var cancel = _window.cancelAnimationFrame || _window.mozCancelAnimationFrame || _window.webkitCancelAnimationFrame || _window.clearTimeout;
      return function (id) {
        return cancel(id);
      };
    }();

    var resetTriggers = function resetTriggers(element) {
      var triggers = element.__resizeTriggers__,
          expand = triggers.firstElementChild,
          contract = triggers.lastElementChild,
          expandChild = expand.firstElementChild;
      contract.scrollLeft = contract.scrollWidth;
      contract.scrollTop = contract.scrollHeight;
      expandChild.style.width = expand.offsetWidth + 1 + 'px';
      expandChild.style.height = expand.offsetHeight + 1 + 'px';
      expand.scrollLeft = expand.scrollWidth;
      expand.scrollTop = expand.scrollHeight;
    };

    var checkTriggers = function checkTriggers(element) {
      return element.offsetWidth != element.__resizeLast__.width || element.offsetHeight != element.__resizeLast__.height;
    };

    var scrollListener = function scrollListener(e) {
      // Don't measure (which forces) reflow for scrolls that happen inside of children!
      if (e.target.className && typeof e.target.className.indexOf === 'function' && e.target.className.indexOf('contract-trigger') < 0 && e.target.className.indexOf('expand-trigger') < 0) {
        return;
      }

      var element = this;
      resetTriggers(this);

      if (this.__resizeRAF__) {
        cancelFrame(this.__resizeRAF__);
      }

      this.__resizeRAF__ = requestFrame(function () {
        if (checkTriggers(element)) {
          element.__resizeLast__.width = element.offsetWidth;
          element.__resizeLast__.height = element.offsetHeight;

          element.__resizeListeners__.forEach(function (fn) {
            fn.call(element, e);
          });
        }
      });
    };
    /* Detect CSS Animations support to detect element display/re-attach */


    var animation = false,
        keyframeprefix = '',
        animationstartevent = 'animationstart',
        domPrefixes = 'Webkit Moz O ms'.split(' '),
        startEvents = 'webkitAnimationStart animationstart oAnimationStart MSAnimationStart'.split(' '),
        pfx = '';
    {
      var elm = _window.document.createElement('fakeelement');

      if (elm.style.animationName !== undefined) {
        animation = true;
      }

      if (animation === false) {
        for (var i = 0; i < domPrefixes.length; i++) {
          if (elm.style[domPrefixes[i] + 'AnimationName'] !== undefined) {
            pfx = domPrefixes[i];
            keyframeprefix = '-' + pfx.toLowerCase() + '-';
            animationstartevent = startEvents[i];
            animation = true;
            break;
          }
        }
      }
    }
    var animationName = 'resizeanim';
    var animationKeyframes = '@' + keyframeprefix + 'keyframes ' + animationName + ' { from { opacity: 0; } to { opacity: 0; } } ';
    var animationStyle = keyframeprefix + 'animation: 1ms ' + animationName + '; ';
  }

  var createStyles = function createStyles(doc) {
    if (!doc.getElementById('detectElementResize')) {
      //opacity:0 works around a chrome bug https://code.google.com/p/chromium/issues/detail?id=286360
      var css = (animationKeyframes ? animationKeyframes : '') + '.resize-triggers { ' + (animationStyle ? animationStyle : '') + 'visibility: hidden; opacity: 0; } ' + '.resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }',
          head = doc.head || doc.getElementsByTagName('head')[0],
          style = doc.createElement('style');
      style.id = 'detectElementResize';
      style.type = 'text/css';

      if (nonce != null) {
        style.setAttribute('nonce', nonce);
      }

      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(doc.createTextNode(css));
      }

      head.appendChild(style);
    }
  };

  var addResizeListener = function addResizeListener(element, fn) {
    if (attachEvent) {
      element.attachEvent('onresize', fn);
    } else {
      if (!element.__resizeTriggers__) {
        var doc = element.ownerDocument;

        var elementStyle = _window.getComputedStyle(element);

        if (elementStyle && elementStyle.position == 'static') {
          element.style.position = 'relative';
        }

        createStyles(doc);
        element.__resizeLast__ = {};
        element.__resizeListeners__ = [];
        (element.__resizeTriggers__ = doc.createElement('div')).className = 'resize-triggers';
        element.__resizeTriggers__.innerHTML = '<div class="expand-trigger"><div></div></div>' + '<div class="contract-trigger"></div>';
        element.appendChild(element.__resizeTriggers__);
        resetTriggers(element);
        element.addEventListener('scroll', scrollListener, true);
        /* Listen for a css animation to detect element display/re-attach */

        if (animationstartevent) {
          element.__resizeTriggers__.__animationListener__ = function animationListener(e) {
            if (e.animationName == animationName) {
              resetTriggers(element);
            }
          };

          element.__resizeTriggers__.addEventListener(animationstartevent, element.__resizeTriggers__.__animationListener__);
        }
      }

      element.__resizeListeners__.push(fn);
    }
  };

  var removeResizeListener = function removeResizeListener(element, fn) {
    if (attachEvent) {
      element.detachEvent('onresize', fn);
    } else {
      element.__resizeListeners__.splice(element.__resizeListeners__.indexOf(fn), 1);

      if (!element.__resizeListeners__.length) {
        element.removeEventListener('scroll', scrollListener, true);

        if (element.__resizeTriggers__.__animationListener__) {
          element.__resizeTriggers__.removeEventListener(animationstartevent, element.__resizeTriggers__.__animationListener__);

          element.__resizeTriggers__.__animationListener__ = null;
        }

        try {
          element.__resizeTriggers__ = !element.removeChild(element.__resizeTriggers__);
        } catch (e) {// Preact compat; see developit/preact-compat/issues/228
        }
      }
    }
  };

  return {
    addResizeListener,
    removeResizeListener
  };
}

class AutoSizer extends _react.Component {
  constructor() {
    super(...arguments);
    this.state = {
      height: this.props.defaultHeight || 0,
      width: this.props.defaultWidth || 0
    };
    this._parentNode = void 0;
    this._autoSizer = void 0;
    this._window = void 0;
    this._detectElementResize = void 0;

    this._onResize = () => {
      const {
        disableHeight,
        disableWidth,
        onResize
      } = this.props;

      if (this._parentNode) {
        // Guard against AutoSizer component being removed from the DOM immediately after being added.
        // This can result in invalid style values which can result in NaN values if we don't handle them.
        // See issue #150 for more context.
        const height = this._parentNode.offsetHeight || 0;
        const width = this._parentNode.offsetWidth || 0;
        const win = this._window || window;
        const style = win.getComputedStyle(this._parentNode) || {};
        const paddingLeft = parseInt(style.paddingLeft, 10) || 0;
        const paddingRight = parseInt(style.paddingRight, 10) || 0;
        const paddingTop = parseInt(style.paddingTop, 10) || 0;
        const paddingBottom = parseInt(style.paddingBottom, 10) || 0;
        const newHeight = height - paddingTop - paddingBottom;
        const newWidth = width - paddingLeft - paddingRight;

        if (!disableHeight && this.state.height !== newHeight || !disableWidth && this.state.width !== newWidth) {
          this.setState({
            height: height - paddingTop - paddingBottom,
            width: width - paddingLeft - paddingRight
          });
          onResize({
            height,
            width
          });
        }
      }
    };

    this._setRef = autoSizer => {
      this._autoSizer = autoSizer;
    };
  }

  componentDidMount() {
    const {
      nonce
    } = this.props;

    if (this._autoSizer && this._autoSizer.parentNode && this._autoSizer.parentNode.ownerDocument && this._autoSizer.parentNode.ownerDocument.defaultView && this._autoSizer.parentNode instanceof this._autoSizer.parentNode.ownerDocument.defaultView.HTMLElement) {
      // Delay access of parentNode until mount.
      // This handles edge-cases where the component has already been unmounted before its ref has been set,
      // As well as libraries like react-lite which have a slightly different lifecycle.
      this._parentNode = this._autoSizer.parentNode;
      this._window = this._autoSizer.parentNode.ownerDocument.defaultView; // Defer requiring resize handler in order to support server-side rendering.
      // See issue #41

      this._detectElementResize = $ca6b875d36bb40f35f34ccb5eee9ec5d$export$default(nonce, this._window);

      this._detectElementResize.addResizeListener(this._parentNode, this._onResize);

      this._onResize();
    }
  }

  componentWillUnmount() {
    if (this._detectElementResize && this._parentNode) {
      this._detectElementResize.removeResizeListener(this._parentNode, this._onResize);
    }
  }

  render() {
    const {
      children,
      className,
      disableHeight,
      disableWidth,
      style
    } = this.props;
    const {
      height,
      width
    } = this.state; // Outer div should not force width/height since that may prevent containers from shrinking.
    // Inner component should overflow and use calculated width/height.
    // See issue #68 for more information.

    const outerStyle = {
      overflow: 'visible'
    };
    const childParams = {};

    if (!disableHeight) {
      outerStyle.height = 0;
      childParams.height = height;
    }

    if (!disableWidth) {
      outerStyle.width = 0;
      childParams.width = width;
    }
    /**
     * TODO: Avoid rendering children before the initial measurements have been collected.
     * At best this would just be wasting cycles.
     * Add this check into version 10 though as it could break too many ref callbacks in version 9.
     * Note that if default width/height props were provided this would still work with SSR.
     if (
     height !== 0 &&
     width !== 0
     ) {
      child = children({ height, width })
    }
     */


    return /*#__PURE__*/_react.createElement("div", {
      className: className,
      ref: this._setRef,
      style: _babelRuntimeHelpersExtends({}, outerStyle, style)
    }, children(childParams));
  }

}

exports.AutoSizer = AutoSizer;
AutoSizer.defaultProps = {
  onResize: () => {},
  disableHeight: false,
  disableWidth: false,
  style: {}
};

class FullDynamicList extends _react.PureComponent {
  constructor(props) {
    super(props);
    this.heightCache = void 0;
    this.layout = void 0;
    this.keys = void 0;
    this.rows = void 0;
    this.useAnchor = void 0;
    this.keyToScrollTo = void 0;

    this.renderRow = (index, a) => {
      return this.props.rowRenderer({
        index,
        hoverProps: a
      });
    };

    this.heightCache = new HeightCache({
      DEFAULT_HEIGHT: props.defaultRowHeight
    });
    this.layout = new Layout({
      heightCache: this.heightCache,
      keys: [],
      stickToBottom: false,
      shouldExcludeFirstItemFromGravity: false,
      STICKY_EPSILON: 0,
      STICKY_EPSILON_SETHEIGHT: 0,
      ANCHOR_OFFSET: 0
    });
    this.keys = props.keys;
    this.rows = [];
    this.state = {
      isLoading: props.isLoading,
      isLoadingNewer: props.isLoadingNewer,
      isLoadingOlder: props.isLoadingOlder
    };
  }

  UNSAFE_componentWillReceiveProps(nextProps) {
    this.setState(prevState => {
      if (nextProps.isLoading !== prevState.isLoading) {
        this.setState({
          isLoading: nextProps.isLoading
        });
      }

      if (nextProps.isLoadingNewer !== prevState.isLoadingNewer) {
        this.setState({
          isLoadingNewer: nextProps.isLoadingNewer
        });
      }

      if (nextProps.isLoadingOlder !== prevState.isLoadingOlder) {
        this.setState({
          isLoadingOlder: nextProps.isLoadingOlder
        });
      }
    });
  }

  render() {
    return /*#__PURE__*/_react.createElement(AutoSizer, {
      style: {
        width: '100%',
        height: '100%'
      }
    }, (_ref) => {
      let {
        width,
        height
      } = _ref;
      return /*#__PURE__*/_react.createElement(MessageDynamicList, {
        layout: this.layout,
        width: width,
        height: height,
        keys: this.keys,
        rowRenderer: this.renderRow
      });
    });
  }

}

exports.FullDynamicList = FullDynamicList;
FullDynamicList.displayName = 'FullDynamicList';
FullDynamicList.defaultProps = {
  defaultRowHeight: 50
};
//# sourceMappingURL=main.js.map
