import * as React from 'react';

// @ts-ignore
const v = function e( t: any, a: any ) {
  return t + '-' + a;
};
// @ts-ignore
const g = {
  add: ( t: any, a: any, r: any ) => {
    // @ts-ignore
    this.sections || ( this.sections = {} );
    const n = v( t, a );
    // @ts-ignore
    if ( this.sections[ n ] )
      throw new Error( 'A section has already been specified at "' + n + '"' );
    // @ts-ignore
    this.sections[ n ] = r;
  },
  remove: ( t: any, a: any ) => {
    // @ts-ignore
    if ( ! this.sections ) return;
    const r = v( t, a );
    // @ts-ignore
    if ( ! this.sections[ r ] ) return;
    // @ts-ignore
    this.sections[ r ] = null;
    // @ts-ignore
    delete this.sections[ r ];
  },
  get: ( t: any, a: any ) => {
    // @ts-ignore
    if ( ! this.sections ) return;
    // @ts-ignore
    return this.sections[ v( t, a ) ];
  },
};

interface Props {
  teamId?: string;
  order: number;
  component?: any;
  children: any;
}

export class FocusableSection extends React.PureComponent<Props> {
  static defaultProps = {
    children: undefined,
  };

  componentDidMount() {
    const t = this.props,
      a = t.teamId,
      r = t.order,
      n = t.component;
    g.add( a, r, n );
  }

  componentWillUnmount() {
    const t = this.props,
      a = t.teamId,
      r = t.order;
    g.remove( a, r );
  }

  render() {
    return this.props.children;
  }
}
